/*
 * uCharts (R)
 * 高性能跨平台图表库，支持H5、APP、小程序（微信/支付宝/百度/头条/QQ/360/快手）、Vue、Taro等支持canvas的框架平台
 * Copyright (C) 2018-2022 QIUN (R) 秋云 https://www.ucharts.cn All rights reserved.
 * Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
 * 复制使用请保留本段注释，感谢支持开源！
 * 
 * uCharts (R) 官方网站
 * https://www.uCharts.cn
 * 
 * 开源地址:
 * https://gitee.com/uCharts/uCharts
 * 
 * uni-app插件市场地址：
 * http://ext.dcloud.net.cn/plugin?id=271
 * 
 */
"use strict";var config={version:"v2.5.0-20230101",yAxisWidth:15,xAxisHeight:22,padding:[10,10,10,10],rotate:false,fontSize:13,fontColor:"#666666",dataPointShape:["circle","circle","circle","circle"],color:["#1890FF","#91CB74","#FAC858","#EE6666","#73C0DE","#3CA272","#FC8452","#9A60B4","#ea7ccc"],linearColor:["#0EE2F8","#2BDCA8","#FA7D8D","#EB88E2","#2AE3A0","#0EE2F8","#EB88E2","#6773E3","#F78A85"],pieChartLinePadding:15,pieChartTextPadding:5,titleFontSize:20,subtitleFontSize:15};var assign=function(e,...t){if(e==null){throw new TypeError("[uCharts] Cannot convert undefined or null to object")}if(!t||t.length<=0){return e}function a(e,i){for(let t in i){e[t]=e[t]&&e[t].toString()==="[object Object]"?a(e[t],i[t]):e[t]=i[t]}return e}t.forEach(t=>{e=a(e,t)});return e};var util={toFixed:function t(e,i){i=i||2;if(this.isFloat(e)){e=e.toFixed(i)}return e},isFloat:function t(e){return e%1!==0},approximatelyEqual:function t(e,i){return Math.abs(e-i)<1e-10},isSameSign:function t(e,i){return Math.abs(e)===e&&Math.abs(i)===i||Math.abs(e)!==e&&Math.abs(i)!==i},isSameXCoordinateArea:function t(e,i){return this.isSameSign(e.x,i.x)},isCollision:function t(e,i){e.end={};e.end.x=e.start.x+e.width;e.end.y=e.start.y-e.height;i.end={};i.end.x=i.start.x+i.width;i.end.y=i.start.y-i.height;var a=i.start.x>e.end.x||i.end.x<e.start.x||i.end.y>e.start.y||i.start.y<e.end.y;return!a}};function getH5Offset(t){t.mp={changedTouches:[]};t.mp.changedTouches.push({x:t.offsetX,y:t.offsetY});return t}function hexToRgb(t,e){var i=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;var a=t.replace(i,function(t,e,i,a){return e+e+i+i+a+a});var r=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(a);var o=parseInt(r[1],16);var n=parseInt(r[2],16);var l=parseInt(r[3],16);return"rgba("+o+","+n+","+l+","+e+")"}function findRange(t,e,i){if(isNaN(t)){throw new Error("[uCharts] series数据需为Number格式")}i=i||10;e=e?e:"upper";var a=1;while(i<1){i*=10;a*=10}if(e==="upper"){t=Math.ceil(t*a)}else{t=Math.floor(t*a)}while(t%i!==0){if(e==="upper"){if(t==t+1){break}t++}else{t--}}return t/a}function calValidDistance(t,e,i,a,r){var o=r.width-r.area[1]-r.area[3];var n=i.eachSpacing*(r.chartData.xAxisData.xAxisPoints.length-1);if(r.type=="mount"&&r.extra&&r.extra.mount&&r.extra.mount.widthRatio&&r.extra.mount.widthRatio>1){if(r.extra.mount.widthRatio>2)r.extra.mount.widthRatio=2;n+=(r.extra.mount.widthRatio-1)*i.eachSpacing}var l=e;if(e>=0){l=0;t.uevent.trigger("scrollLeft");t.scrollOption.position="left";r.xAxis.scrollPosition="left"}else if(Math.abs(e)>=n-o){l=o-n;t.uevent.trigger("scrollRight");t.scrollOption.position="right";r.xAxis.scrollPosition="right"}else{t.scrollOption.position=e;r.xAxis.scrollPosition=e}return l}function isInAngleRange(t,e,i){function a(t){while(t<0){t+=2*Math.PI}while(t>2*Math.PI){t-=2*Math.PI}return t}t=a(t);e=a(e);i=a(i);if(e>i){i+=2*Math.PI;if(t<e){t+=2*Math.PI}}return t>=e&&t<=i}function createCurveControlPoints(t,e){function i(t,e){if(t[e-1]&&t[e+1]){return t[e].y>=Math.max(t[e-1].y,t[e+1].y)||t[e].y<=Math.min(t[e-1].y,t[e+1].y)}else{return false}}function x(t,e){if(t[e-1]&&t[e+1]){return t[e].x>=Math.max(t[e-1].x,t[e+1].x)||t[e].x<=Math.min(t[e-1].x,t[e+1].x)}else{return false}}var a=.2;var r=.2;var o=null;var n=null;var l=null;var s=null;if(e<1){o=t[0].x+(t[1].x-t[0].x)*a;n=t[0].y+(t[1].y-t[0].y)*a}else{o=t[e].x+(t[e+1].x-t[e-1].x)*a;n=t[e].y+(t[e+1].y-t[e-1].y)*a}if(e>t.length-3){var h=t.length-1;l=t[h].x-(t[h].x-t[h-1].x)*r;s=t[h].y-(t[h].y-t[h-1].y)*r}else{l=t[e+1].x-(t[e+2].x-t[e].x)*r;s=t[e+1].y-(t[e+2].y-t[e].y)*r}if(i(t,e+1)){s=t[e+1].y}if(i(t,e)){n=t[e].y}if(x(t,e+1)){l=t[e+1].x}if(x(t,e)){o=t[e].x}if(n>=Math.max(t[e].y,t[e+1].y)||n<=Math.min(t[e].y,t[e+1].y)){n=t[e].y}if(s>=Math.max(t[e].y,t[e+1].y)||s<=Math.min(t[e].y,t[e+1].y)){s=t[e+1].y}if(o>=Math.max(t[e].x,t[e+1].x)||o<=Math.min(t[e].x,t[e+1].x)){o=t[e].x}if(l>=Math.max(t[e].x,t[e+1].x)||l<=Math.min(t[e].x,t[e+1].x)){l=t[e+1].x}return{ctrA:{x:o,y:n},ctrB:{x:l,y:s}}}function convertCoordinateOrigin(t,e,i){return{x:i.x+t,y:i.y-e}}function avoidCollision(t,e){if(e){while(util.isCollision(t,e)){if(t.start.x>0){t.start.y--}else if(t.start.x<0){t.start.y++}else{if(t.start.y>0){t.start.y++}else{t.start.y--}}}}return t}function fixPieSeries(e,i,t){let a=[];if(e.length>0&&e[0].data.constructor.toString().indexOf("Array")>-1){i._pieSeries_=e;let t=e[0].data;for(var r=0;r<t.length;r++){t[r].formatter=e[0].formatter;t[r].data=t[r].value;a.push(t[r])}i.series=a}else{a=e}return a}function fillSeries(e,i,a){var r=0;for(var o=0;o<e.length;o++){let t=e[o];if(!t.color){t.color=a.color[r];r=(r+1)%a.color.length}if(!t.linearIndex){t.linearIndex=o}if(!t.index){t.index=0}if(!t.type){t.type=i.type}if(typeof t.show=="undefined"){t.show=true}if(!t.type){t.type=i.type}if(!t.pointShape){t.pointShape="circle"}if(!t.legendShape){switch(t.type){case"line":t.legendShape="line";break;case"column":case"bar":t.legendShape="rect";break;case"area":case"mount":t.legendShape="triangle";break;default:t.legendShape="circle"}}}return e}function fillCustomColor(t,e,i,a){var r=e||[];if(t=="custom"&&r.length==0){r=a.linearColor}if(t=="custom"&&r.length<i.length){let t=i.length-r.length;for(var o=0;o<t;o++){r.push(a.linearColor[(o+1)%a.linearColor.length])}}return r}function getDataRange(t,e){var i=0;var a=e-t;if(a>=1e4){i=1e3}else if(a>=1e3){i=100}else if(a>=100){i=10}else if(a>=10){i=5}else if(a>=1){i=1}else if(a>=.1){i=.1}else if(a>=.01){i=.01}else if(a>=.001){i=.001}else if(a>=1e-4){i=1e-4}else if(a>=1e-5){i=1e-5}else{i=1e-6}return{minRange:findRange(t,"lower",i),maxRange:findRange(e,"upper",i)}}function measureText(i,t,e){var a=0;i=String(i);e=false;if(e!==false&&e!==undefined&&e.setFontSize&&e.measureText){e.setFontSize(t);return e.measureText(i).width}else{var i=i.split("");for(let e=0;e<i.length;e++){let t=i[e];if(/[a-zA-Z]/.test(t)){a+=7}else if(/[0-9]/.test(t)){a+=5.5}else if(/\./.test(t)){a+=2.7}else if(/-/.test(t)){a+=3.25}else if(/:/.test(t)){a+=2.5}else if(/[\u4e00-\u9fa5]/.test(t)){a+=10}else if(/\(|\)/.test(t)){a+=3.73}else if(/\s/.test(t)){a+=2.5}else if(/%/.test(t)){a+=8}else{a+=10}}return a*t/10}}function dataCombine(t){return t.reduce(function(t,e){return(t.data?t.data:t).concat(e.data)},[])}function dataCombineStack(t,e){var i=new Array(e);for(var a=0;a<i.length;a++){i[a]=0}for(var r=0;r<t.length;r++){for(var a=0;a<i.length;a++){i[a]+=t[r].data[a]}}return t.reduce(function(t,e){return(t.data?t.data:t).concat(e.data).concat(i)},[])}function getTouches(t,e,i){let a,r;if(t.clientX){if(e.rotate){r=e.height-t.clientX*e.pix;a=(t.pageY-i.currentTarget.offsetTop-e.height/e.pix/2*(e.pix-1))*e.pix}else{a=t.clientX*e.pix;r=(t.pageY-i.currentTarget.offsetTop-e.height/e.pix/2*(e.pix-1))*e.pix}}else{if(e.rotate){r=e.height-t.x*e.pix;a=t.y*e.pix}else{a=t.x*e.pix;r=t.y*e.pix}}return{x:a,y:r}}function getSeriesDataItem(e,a,i){var r=[];var o=[];var n=a.constructor.toString().indexOf("Array")>-1;if(n){let t=filterSeries(e);for(var l=0;l<i.length;l++){o.push(t[i[l]])}}else{o=e}for(let t=0;t<o.length;t++){let e=o[t];let i=-1;if(n){i=a[t]}else{i=a}if(e.data[i]!==null&&typeof e.data[i]!=="undefined"&&e.show){let t={};t.color=e.color;t.type=e.type;t.style=e.style;t.pointShape=e.pointShape;t.disableLegend=e.disableLegend;t.legendShape=e.legendShape;t.name=e.name;t.show=e.show;t.data=e.formatter?e.formatter(e.data[i]):e.data[i];r.push(t)}}return r}function getToolTipData(t,i,a,r,o){var n=arguments.length>5&&arguments[5]!==undefined?arguments[5]:{};var l=i.chartData.calPoints?i.chartData.calPoints:[];let s={};if(r.length>0){let e=[];for(let t=0;t<r.length;t++){e.push(l[r[t]])}s=e[0][a[0]]}else{for(let t=0;t<l.length;t++){if(l[t][a]){s=l[t][a];break}}}var e=t.map(function(t){let e=null;if(i.categories&&i.categories.length>0){e=o[a]}return{text:n.formatter?n.formatter(t,e,a,i):t.name+": "+t.data,color:t.color,legendShape:i.extra.tooltip.legendShape=="auto"?t.legendShape:i.extra.tooltip.legendShape}});var h={x:Math.round(s.x),y:Math.round(s.y)};return{textList:e,offset:h}}function getMixToolTipData(t,e,i,a){var r=arguments.length>4&&arguments[4]!==undefined?arguments[4]:{};var o=e.chartData.xAxisPoints[i]+e.chartData.eachSpacing/2;var n=t.map(function(t){return{text:r.formatter?r.formatter(t,a[i],i,e):t.name+": "+t.data,color:t.color,disableLegend:t.disableLegend?true:false,legendShape:e.extra.tooltip.legendShape=="auto"?t.legendShape:e.extra.tooltip.legendShape}});n=n.filter(function(t){if(t.disableLegend!==true){return t}});var l={x:Math.round(o),y:0};return{textList:n,offset:l}}function filterSeries(e){let i=[];for(let t=0;t<e.length;t++){if(e[t].show==true){i.push(e[t])}}return i}function findCurrentIndex(o,n,e,t){var i=arguments.length>4&&arguments[4]!==undefined?arguments[4]:0;var l={index:-1,group:[]};var a=e.chartData.eachSpacing/2;let r=[];if(n&&n.length>0){if(!e.categories){a=0}else{for(let t=1;t<e.chartData.xAxisPoints.length;t++){r.push(e.chartData.xAxisPoints[t]-a)}if((e.type=="line"||e.type=="area")&&e.xAxis.boundaryGap=="justify"){r=e.chartData.xAxisPoints}}if(isInExactChartArea(o,e,t)){if(!e.categories){let i=Array(n.length);for(let e=0;e<n.length;e++){i[e]=Array(n[e].length);for(let t=0;t<n[e].length;t++){i[e][t]=Math.abs(n[e][t].x-o.x)}}let e=Array(i.length);let a=Array(i.length);for(let t=0;t<i.length;t++){e[t]=Math.min.apply(null,i[t]);a[t]=i[t].indexOf(e[t])}let r=Math.min.apply(null,e);l.index=[];for(let t=0;t<e.length;t++){if(e[t]==r){l.group.push(t);l.index.push(a[t])}}}else{r.forEach(function(t,e){if(o.x+i+a>t){l.index=e}})}}}return l}function findBarChartCurrentIndex(i,t,e,a){var r=arguments.length>4&&arguments[4]!==undefined?arguments[4]:0;var o={index:-1,group:[]};var n=e.chartData.eachSpacing/2;let l=e.chartData.yAxisPoints;if(t&&t.length>0){if(isInExactChartArea(i,e,a)){l.forEach(function(t,e){if(i.y+r+n>t){o.index=e}})}}return o}function findLegendIndex(o,t,e){let n=-1;let l=0;if(isInExactLegendArea(o,t.area)){let a=t.points;let r=-1;for(let t=0,e=a.length;t<e;t++){let i=a[t];for(let e=0;e<i.length;e++){r+=1;let t=i[e]["area"];if(t&&o.x>t[0]-l&&o.x<t[2]+l&&o.y>t[1]-l&&o.y<t[3]+l){n=r;break}}}return n}return n}function isInExactLegendArea(t,e){return t.x>e.start.x&&t.x<e.end.x&&t.y>e.start.y&&t.y<e.end.y}function isInExactChartArea(t,e,i){return t.x<=e.width-e.area[1]+10&&t.x>=e.area[3]-10&&t.y>=e.area[0]&&t.y<=e.height-e.area[2]}function findRoseChartCurrentIndex(t,e,i){var a=-1;var r=getRoseDataPoints(i._series_,i.extra.rose.type,e.radius,e.radius);if(e&&e.center&&isInExactPieChartArea(t,e.center,e.radius)){var o=Math.atan2(e.center.y-t.y,t.x-e.center.x);o=-o;if(i.extra.rose&&i.extra.rose.offsetAngle){o=o-i.extra.rose.offsetAngle*Math.PI/180}for(var n=0,l=r.length;n<l;n++){if(isInAngleRange(o,r[n]._start_,r[n]._start_+r[n]._rose_proportion_*2*Math.PI)){a=n;break}}}return a}function findPieChartCurrentIndex(t,e,i){var a=-1;var r=getPieDataPoints(e.series);if(e&&e.center&&isInExactPieChartArea(t,e.center,e.radius)){var o=Math.atan2(e.center.y-t.y,t.x-e.center.x);o=-o;if(i.extra.pie&&i.extra.pie.offsetAngle){o=o-i.extra.pie.offsetAngle*Math.PI/180}if(i.extra.ring&&i.extra.ring.offsetAngle){o=o-i.extra.ring.offsetAngle*Math.PI/180}for(var n=0,l=r.length;n<l;n++){if(isInAngleRange(o,r[n]._start_,r[n]._start_+r[n]._proportion_*2*Math.PI)){a=n;break}}}return a}function isInExactPieChartArea(t,e,i){return Math.pow(t.x-e.x,2)+Math.pow(t.y-e.y,2)<=Math.pow(i,2)}function splitPoints(t,i){var a=[];var r=[];t.forEach(function(t,e){if(i.connectNulls){if(t!==null){r.push(t)}}else{if(t!==null){r.push(t)}else{if(r.length){a.push(r)}r=[]}}});if(r.length){a.push(r)}return a}function calLegendData(l,s,e,t,h){let x={area:{start:{x:0,y:0},end:{x:0,y:0},width:0,height:0,wholeWidth:0,wholeHeight:0},points:[],widthArr:[],heightArr:[]};if(s.legend.show===false){t.legendData=x;return x}let c=s.legend.padding*s.pix;let f=s.legend.margin*s.pix;let d=s.legend.fontSize?s.legend.fontSize*s.pix:e.fontSize;let p=15*s.pix;let g=5*s.pix;let u=Math.max(s.legend.lineHeight*s.pix,d);if(s.legend.position=="top"||s.legend.position=="bottom"){let a=[];let r=0;let o=[];let n=[];for(let i=0;i<l.length;i++){let t=l[i];const y=t.legendText?t.legendText:t.name;let e=p+g+measureText(y||"undefined",d,h)+s.legend.itemGap*s.pix;if(r+e>s.width-s.area[1]-s.area[3]){a.push(n);o.push(r-s.legend.itemGap*s.pix);r=e;n=[t]}else{r+=e;n.push(t)}}if(n.length){a.push(n);o.push(r-s.legend.itemGap*s.pix);x.widthArr=o;let t=Math.max.apply(null,o);switch(s.legend.float){case"left":x.area.start.x=s.area[3];x.area.end.x=s.area[3]+t+2*c;break;case"right":x.area.start.x=s.width-s.area[1]-t-2*c;x.area.end.x=s.width-s.area[1];break;default:x.area.start.x=(s.width-t)/2-c;x.area.end.x=(s.width+t)/2+c}x.area.width=t+2*c;x.area.wholeWidth=t+2*c;x.area.height=a.length*u+2*c;x.area.wholeHeight=a.length*u+2*c+2*f;x.points=a}}else{let t=l.length;let e=s.height-s.area[0]-s.area[2]-2*f-2*c;let i=Math.min(Math.floor(e/u),t);x.area.height=i*u+c*2;x.area.wholeHeight=i*u+c*2;switch(s.legend.float){case"top":x.area.start.y=s.area[0]+f;x.area.end.y=s.area[0]+f+x.area.height;break;case"bottom":x.area.start.y=s.height-s.area[2]-f-x.area.height;x.area.end.y=s.height-s.area[2]-f;break;default:x.area.start.y=(s.height-x.area.height)/2;x.area.end.y=(s.height+x.area.height)/2}let a=t%i===0?t/i:Math.floor(t/i+1);let r=[];for(let e=0;e<a;e++){let t=l.slice(e*i,e*i+i);r.push(t)}x.points=r;if(r.length){for(let t=0;t<r.length;t++){let i=r[t];let a=0;for(let e=0;e<i.length;e++){let t=p+g+measureText(i[e].name||"undefined",d,h)+s.legend.itemGap*s.pix;if(t>a){a=t}}x.widthArr.push(a);x.heightArr.push(i.length*u+c*2)}let e=0;for(let t=0;t<x.widthArr.length;t++){e+=x.widthArr[t]}x.area.width=e-s.legend.itemGap*s.pix+2*c;x.area.wholeWidth=x.area.width+c}}switch(s.legend.position){case"top":x.area.start.y=s.area[0]+f;x.area.end.y=s.area[0]+f+x.area.height;break;case"bottom":x.area.start.y=s.height-s.area[2]-x.area.height-f;x.area.end.y=s.height-s.area[2]-f;break;case"left":x.area.start.x=s.area[3];x.area.end.x=s.area[3]+x.area.width;break;case"right":x.area.start.x=s.width-s.area[1]-x.area.width;x.area.end.x=s.width-s.area[1];break}t.legendData=x;return x}function calCategoriesData(t,a,e,i,r){var o={angle:0,xAxisHeight:a.xAxis.lineHeight*a.pix+a.xAxis.marginTop*a.pix};var n=a.xAxis.fontSize*a.pix;var l=t.map(function(t,e){var i=a.xAxis.formatter?a.xAxis.formatter(t,e,a):t;return measureText(String(i),n,r)});var s=Math.max.apply(this,l);if(a.xAxis.rotateLabel==true){o.angle=a.xAxis.rotateAngle*Math.PI/180;let t=a.xAxis.marginTop*a.pix*2+Math.abs(s*Math.sin(o.angle));t=t<n+a.xAxis.marginTop*a.pix*2?t+a.xAxis.marginTop*a.pix*2:t;o.xAxisHeight=t}if(a.enableScroll&&a.xAxis.scrollShow){o.xAxisHeight+=6*a.pix}if(a.xAxis.disabled){o.xAxisHeight=0}return o}function getXAxisTextList(t,e,h,x){var i=arguments.length>4&&arguments[4]!==undefined?arguments[4]:-1;var a;if(x=="stack"){a=dataCombineStack(t,e.categories.length)}else{a=dataCombine(t)}var r=[];a=a.filter(function(t){if(typeof t==="object"&&t!==null){if(t.constructor.toString().indexOf("Array")>-1){return t!==null}else{return t.value!==null}}else{return t!==null}});a.map(function(t){if(typeof t==="object"){if(t.constructor.toString().indexOf("Array")>-1){if(e.type=="candle"){t.map(function(t){r.push(t)})}else{r.push(t[0])}}else{r.push(t.value)}}else{r.push(t)}});var o=0;var n=0;if(r.length>0){o=Math.min.apply(this,r);n=Math.max.apply(this,r)}if(i>-1){if(typeof e.xAxis.data[i].min==="number"){o=Math.min(e.xAxis.data[i].min,o)}if(typeof e.xAxis.data[i].max==="number"){n=Math.max(e.xAxis.data[i].max,n)}}else{if(typeof e.xAxis.min==="number"){o=Math.min(e.xAxis.min,o)}if(typeof e.xAxis.max==="number"){n=Math.max(e.xAxis.max,n)}}if(o===n){var c=n||10;n+=c}var l=o;var f=n;var d=[];var p=(f-l)/e.xAxis.splitNumber;for(var s=0;s<=e.xAxis.splitNumber;s++){d.push(l+p*s)}return d}function calXAxisData(t,e,i,a){var r=assign({},{type:""},e.extra.bar);var o={angle:0,xAxisHeight:e.xAxis.lineHeight*e.pix+e.xAxis.marginTop*e.pix};o.ranges=getXAxisTextList(t,e,i,r.type);o.rangesFormat=o.ranges.map(function(t){t=util.toFixed(t,2);return t});var n=o.ranges.map(function(t){t=util.toFixed(t,2);return t});o=Object.assign(o,getXAxisPoints(n,e,i));var l=o.eachSpacing;var s=n.map(function(t){return measureText(t,e.xAxis.fontSize*e.pix,a)});if(e.xAxis.disabled===true){o.xAxisHeight=0}return o}function getPieDataPoints(i,a){var r=arguments.length>2&&arguments[2]!==undefined?arguments[2]:1;var o=0;var n=0;for(let e=0;e<i.length;e++){let t=i[e];t.data=t.data===null?0:t.data;o+=t.data}for(let e=0;e<i.length;e++){let t=i[e];t.data=t.data===null?0:t.data;if(o===0){t._proportion_=1/i.length*r}else{t._proportion_=t.data/o*r}t._radius_=a}for(let e=0;e<i.length;e++){let t=i[e];t._start_=n;n+=2*t._proportion_*Math.PI}return i}function getRoseDataPoints(i,a,r,o){var n=arguments.length>4&&arguments[4]!==undefined?arguments[4]:1;var l=0;var s=0;var h=[];for(let e=0;e<i.length;e++){let t=i[e];t.data=t.data===null?0:t.data;l+=t.data;h.push(t.data)}var x=Math.min.apply(null,h);var c=Math.max.apply(null,h);var f=o-r;for(let e=0;e<i.length;e++){let t=i[e];t.data=t.data===null?0:t.data;if(l===0){t._proportion_=1/i.length*n;t._rose_proportion_=1/i.length*n}else{t._proportion_=t.data/l*n;if(a=="area"){t._rose_proportion_=1/i.length*n}else{t._rose_proportion_=t.data/l*n}}t._radius_=r+f*((t.data-x)/(c-x))||o}for(let e=0;e<i.length;e++){let t=i[e];t._start_=s;s+=2*t._rose_proportion_*Math.PI}return i}function getPieTextMaxLength(a,r,o,n){a=getPieDataPoints(a);let l=0;for(let i=0;i<a.length;i++){let t=a[i];let e=t.formatter?t.formatter(+t._proportion_.toFixed(2)):util.toFixed(t._proportion_*100)+"%";l=Math.max(l,measureText(e,t.textSize*n.pix||r.fontSize,o))}return l}function fixColumeData(t,a,r,o,e,n){return t.map(function(t){if(t===null){return null}var e=0;var i=0;if(n.type=="mix"){e=n.extra.mix.column.seriesGap*n.pix||0;i=n.extra.mix.column.categoryGap*n.pix||0}else{e=n.extra.column.seriesGap*n.pix||0;i=n.extra.column.categoryGap*n.pix||0}e=Math.min(e,a/r);i=Math.min(i,a/r);t.width=Math.ceil((a-2*i-e*(r-1))/r);if(n.extra.mix&&n.extra.mix.column.width&&+n.extra.mix.column.width>0){t.width=Math.min(t.width,+n.extra.mix.column.width*n.pix)}if(n.extra.column&&n.extra.column.width&&+n.extra.column.width>0){t.width=Math.min(t.width,+n.extra.column.width*n.pix)}if(t.width<=0){t.width=1}t.x+=(o+.5-r/2)*(t.width+e);return t})}function fixBarData(t,a,r,o,e,n){return t.map(function(t){if(t===null){return null}var e=0;var i=0;e=n.extra.bar.seriesGap*n.pix||0;i=n.extra.bar.categoryGap*n.pix||0;e=Math.min(e,a/r);i=Math.min(i,a/r);t.width=Math.ceil((a-2*i-e*(r-1))/r);if(n.extra.bar&&n.extra.bar.width&&+n.extra.bar.width>0){t.width=Math.min(t.width,+n.extra.bar.width*n.pix)}if(t.width<=0){t.width=1}t.y+=(o+.5-r/2)*(t.width+e);return t})}function fixColumeMeterData(t,e,i,a,r,o,n){var l=o.extra.column.categoryGap*o.pix||0;return t.map(function(t){if(t===null){return null}t.width=e-2*l;if(o.extra.column&&o.extra.column.width&&+o.extra.column.width>0){t.width=Math.min(t.width,+o.extra.column.width*o.pix)}if(a>0){t.width-=n}return t})}function fixColumeStackData(t,i,e,a,r,o,n){var l=o.extra.column.categoryGap*o.pix||0;return t.map(function(t,e){if(t===null){return null}t.width=Math.ceil(i-2*l);if(o.extra.column&&o.extra.column.width&&+o.extra.column.width>0){t.width=Math.min(t.width,+o.extra.column.width*o.pix)}if(t.width<=0){t.width=1}return t})}function fixBarStackData(t,i,e,a,r,o,n){var l=o.extra.bar.categoryGap*o.pix||0;return t.map(function(t,e){if(t===null){return null}t.width=Math.ceil(i-2*l);if(o.extra.bar&&o.extra.bar.width&&+o.extra.bar.width>0){t.width=Math.min(t.width,+o.extra.bar.width*o.pix)}if(t.width<=0){t.width=1}return t})}function getXAxisPoints(t,e,h){var i=e.width-e.area[1]-e.area[3];var a=e.enableScroll?Math.min(e.xAxis.itemCount,t.length):t.length;if((e.type=="line"||e.type=="area"||e.type=="scatter"||e.type=="bubble"||e.type=="bar")&&a>1&&e.xAxis.boundaryGap=="justify"){a-=1}var r=0;if(e.type=="mount"&&e.extra&&e.extra.mount&&e.extra.mount.widthRatio&&e.extra.mount.widthRatio>1){if(e.extra.mount.widthRatio>2)e.extra.mount.widthRatio=2;r=e.extra.mount.widthRatio-1;a+=r}var o=i/a;var n=[];var l=e.area[3];var s=e.width-e.area[1];t.forEach(function(t,e){n.push(l+r/2*o+e*o)});if(e.xAxis.boundaryGap!=="justify"){if(e.enableScroll===true){n.push(l+r*o+t.length*o)}else{n.push(s)}}return{xAxisPoints:n,startX:l,endX:s,eachSpacing:o}}function getDataPoints(t,i,n,l,s,h,e){var x=arguments.length>7&&arguments[7]!==undefined?arguments[7]:1;var c="center";if(h.type=="line"||h.type=="area"||h.type=="scatter"||h.type=="bubble"){c=h.xAxis.boundaryGap}var f=[];var d=h.height-h.area[0]-h.area[2];var p=h.width-h.area[1]-h.area[3];t.forEach(function(a,t){if(a===null){f.push(null)}else{var r={};r.color=a.color;r.x=l[t];var o=a;if(typeof a==="object"&&a!==null){if(a.constructor.toString().indexOf("Array")>-1){let t,e,i;t=[].concat(h.chartData.xAxisData.ranges);e=t.shift();i=t.pop();o=a[1];r.x=h.area[3]+p*(a[0]-e)/(i-e);if(h.type=="bubble"){r.r=a[2];r.t=a[3]}}else{o=a.value}}if(c=="center"){r.x+=s/2}var e=d*(o-i)/(n-i);e*=x;r.y=h.height-e-h.area[2];f.push(r)}});return f}function getLineDataPoints(t,i,n,l,s,h,e,p,x){var x=arguments.length>8&&arguments[8]!==undefined?arguments[8]:1;var c=h.xAxis.boundaryGap;var f=[];var d=h.height-h.area[0]-h.area[2];var u=h.width-h.area[1]-h.area[3];t.forEach(function(a,t){if(a===null){f.push(null)}else{var r={};r.color=a.color;if(p.animation=="vertical"){r.x=l[t];var o=a;if(typeof a==="object"&&a!==null){if(a.constructor.toString().indexOf("Array")>-1){let t,e,i;t=[].concat(h.chartData.xAxisData.ranges);e=t.shift();i=t.pop();o=a[1];r.x=h.area[3]+u*(a[0]-e)/(i-e)}else{o=a.value}}if(c=="center"){r.x+=s/2}var e=d*(o-i)/(n-i);e*=x;r.y=h.height-e-h.area[2];f.push(r)}else{r.x=l[0]+s*t*x;var o=a;if(c=="center"){r.x+=s/2}var e=d*(o-i)/(n-i);r.y=h.height-e-h.area[2];f.push(r)}}});return f}function getColumnDataPoints(t,i,n,l,s,h,e,a,x){var x=arguments.length>8&&arguments[8]!==undefined?arguments[8]:1;var c=[];var f=h.height-h.area[0]-h.area[2];var d=h.width-h.area[1]-h.area[3];t.forEach(function(a,t){if(a===null){c.push(null)}else{var r={};r.color=a.color;r.x=l[t];var o=a;if(typeof a==="object"&&a!==null){if(a.constructor.toString().indexOf("Array")>-1){let t,e,i;t=[].concat(h.chartData.xAxisData.ranges);e=t.shift();i=t.pop();o=a[1];r.x=h.area[3]+d*(a[0]-e)/(i-e)}else{o=a.value}}r.x+=s/2;var e=f*(o*x-i)/(n-i);r.y=h.height-e-h.area[2];c.push(r)}});return c}function getBarDataPoints(t,o,n,l,e,s,i){var h=arguments.length>7&&arguments[7]!==undefined?arguments[7]:1;var x=[];var a=s.height-s.area[0]-s.area[2];var c=s.width-s.area[1]-s.area[3];t.forEach(function(t,e){if(t===null){x.push(null)}else{var i={};i.color=t.color;i.y=l[e];var a=t;if(typeof t==="object"&&t!==null){a=t.value}var r=c*(a-o)/(n-o);r*=h;i.height=r;i.value=a;i.x=r+s.area[3];x.push(i)}});return x}function getStackDataPoints(t,s,h,x,g,c,e,f,y){var d=arguments.length>9&&arguments[9]!==undefined?arguments[9]:1;var p=[];var u=c.height-c.area[0]-c.area[2];t.forEach(function(t,e){if(t===null){p.push(null)}else{var i={};i.color=t.color;i.x=x[e]+Math.round(g/2);if(f>0){var a=0;for(let t=0;t<=f;t++){a+=y[t].data[e]}var r=a-t;var o=u*(a-s)/(h-s);var n=u*(r-s)/(h-s)}else{var a=t;if(typeof t==="object"&&t!==null){a=t.value}var o=u*(a-s)/(h-s);var n=0}var l=n;o*=d;l*=d;i.y=c.height-Math.round(o)-c.area[2];i.y0=c.height-Math.round(l)-c.area[2];p.push(i)}});return p}function getBarStackDataPoints(t,s,h,x,e,c,i,f,g){var d=arguments.length>9&&arguments[9]!==undefined?arguments[9]:1;var p=[];var u=c.width-c.area[1]-c.area[3];t.forEach(function(t,e){if(t===null){p.push(null)}else{var i={};i.color=t.color;i.y=x[e];if(f>0){var a=0;for(let t=0;t<=f;t++){a+=g[t].data[e]}var r=a-t;var o=u*(a-s)/(h-s);var n=u*(r-s)/(h-s)}else{var a=t;if(typeof t==="object"&&t!==null){a=t.value}var o=u*(a-s)/(h-s);var n=0}var l=n;o*=d;l*=d;i.height=o-l;i.x=c.area[3]+o;i.x0=c.area[3]+l;p.push(i)}});return p}function getYAxisTextList(t,e,h,x,i){var c=arguments.length>5&&arguments[5]!==undefined?arguments[5]:-1;var a;if(x=="stack"){a=dataCombineStack(t,e.categories.length)}else{a=dataCombine(t)}var r=[];a=a.filter(function(t){if(typeof t==="object"&&t!==null){if(t.constructor.toString().indexOf("Array")>-1){return t!==null}else{return t.value!==null}}else{return t!==null}});a.map(function(t){if(typeof t==="object"){if(t.constructor.toString().indexOf("Array")>-1){if(e.type=="candle"){t.map(function(t){r.push(t)})}else{r.push(t[1])}}else{r.push(t.value)}}else{r.push(t)}});var o=i.min||0;var n=i.max||0;if(r.length>0){o=Math.min.apply(this,r);n=Math.max.apply(this,r)}if(o===n){if(n==0){n=10}else{o=0}}var l=getDataRange(o,n);var f=i.min===undefined||i.min===null?l.minRange:i.min;var d=i.max===undefined||i.max===null?l.maxRange:i.max;var p=(d-f)/e.yAxis.splitNumber;var u=[];for(var s=0;s<=e.yAxis.splitNumber;s++){u.push(f+p*s)}return u.reverse()}function calYAxisData(i,o,e,n){var l=assign({},{type:""},o.extra.column);var t=o.yAxis.data.length;var s=new Array(t);if(t>0){for(let e=0;e<t;e++){s[e]=[];for(let t=0;t<i.length;t++){if(i[t].index==e){s[e].push(i[t])}}}var h=new Array(t);var x=new Array(t);var c=new Array(t);for(let r=0;r<t;r++){let a=o.yAxis.data[r];if(o.yAxis.disabled==true){a.disabled=true}if(a.type==="categories"){if(!a.formatter){a.formatter=(t,e,i)=>{return t+(a.unit||"")}}a.categories=a.categories||o.categories;h[r]=a.categories}else{if(!a.formatter){a.formatter=(t,e,i)=>{return util.toFixed(t,a.tofix||0)+(a.unit||"")}}h[r]=getYAxisTextList(s[r],o,e,l.type,a,r)}let i=a.fontSize*o.pix||e.fontSize;c[r]={position:a.position?a.position:"left",width:0};x[r]=h[r].map(function(t,e){t=a.formatter(t,e,o);c[r].width=Math.max(c[r].width,measureText(t,i,n)+5);return t});let t=a.calibration?4*o.pix:0;c[r].width+=t+3*o.pix;if(a.disabled===true){c[r].width=0}}}else{var h=new Array(1);var x=new Array(1);var c=new Array(1);if(o.type==="bar"){h[0]=o.categories;if(!o.yAxis.formatter){o.yAxis.formatter=(t,e,i)=>{return t+(i.yAxis.unit||"")}}}else{if(!o.yAxis.formatter){o.yAxis.formatter=(t,e,i)=>{return t.toFixed(i.yAxis.tofix)+(i.yAxis.unit||"")}}h[0]=getYAxisTextList(i,o,e,l.type,{})}c[0]={position:"left",width:0};var a=o.yAxis.fontSize*o.pix||e.fontSize;x[0]=h[0].map(function(t,e){t=o.yAxis.formatter(t,e,o);c[0].width=Math.max(c[0].width,measureText(t,a,n)+5);return t});c[0].width+=3*o.pix;if(o.yAxis.disabled===true){c[0]={position:"left",width:0};o.yAxis.data[0]={disabled:true}}else{o.yAxis.data[0]={disabled:false,position:"left",max:o.yAxis.max,min:o.yAxis.min,formatter:o.yAxis.formatter};if(o.type==="bar"){o.yAxis.data[0].categories=o.categories;o.yAxis.data[0].type="categories"}}}return{rangesFormat:x,ranges:h,yAxisWidth:c}}function calTooltipYAxisData(r,t,o,e,i){let n=[].concat(o.chartData.yAxisData.ranges);let l=o.height-o.area[0]-o.area[2];let s=o.area[0];let h=[];for(let a=0;a<n.length;a++){let t=Math.max.apply(this,n[a]);let e=Math.min.apply(this,n[a]);let i=t-(t-e)*(r-s)/l;i=o.yAxis.data&&o.yAxis.data[a].formatter?o.yAxis.data[a].formatter(i,a,o):i.toFixed(0);h.push(String(i))}return h}function calMarkLineData(a,r){let o,n;let l=r.height-r.area[0]-r.area[2];for(let i=0;i<a.length;i++){a[i].yAxisIndex=a[i].yAxisIndex?a[i].yAxisIndex:0;let t=[].concat(r.chartData.yAxisData.ranges[a[i].yAxisIndex]);o=t.pop();n=t.shift();let e=l*(a[i].value-o)/(n-o);a[i].y=r.height-Math.round(e)-r.area[2]}return a}function contextRotate(t,e){if(e.rotateLock!==true){t.translate(e.height,0);t.rotate(90*Math.PI/180)}else if(e._rotate_!==true){t.translate(e.height,0);t.rotate(90*Math.PI/180);e._rotate_=true}}function drawPointShape(t,e,i,a,r){a.beginPath();if(r.dataPointShapeType=="hollow"){a.setStrokeStyle(e);a.setFillStyle(r.background);a.setLineWidth(2*r.pix)}else{a.setStrokeStyle("#ffffff");a.setFillStyle(e);a.setLineWidth(1*r.pix)}if(i==="diamond"){t.forEach(function(t,e){if(t!==null){a.moveTo(t.x,t.y-4.5);a.lineTo(t.x-4.5,t.y);a.lineTo(t.x,t.y+4.5);a.lineTo(t.x+4.5,t.y);a.lineTo(t.x,t.y-4.5)}})}else if(i==="circle"){t.forEach(function(t,e){if(t!==null){a.moveTo(t.x+2.5*r.pix,t.y);a.arc(t.x,t.y,3*r.pix,0,2*Math.PI,false)}})}else if(i==="square"){t.forEach(function(t,e){if(t!==null){a.moveTo(t.x-3.5,t.y-3.5);a.rect(t.x-3.5,t.y-3.5,7,7)}})}else if(i==="triangle"){t.forEach(function(t,e){if(t!==null){a.moveTo(t.x,t.y-4.5);a.lineTo(t.x-4.5,t.y+4.5);a.lineTo(t.x+4.5,t.y+4.5);a.lineTo(t.x,t.y-4.5)}})}else if(i==="none"){return}a.closePath();a.fill();a.stroke()}function drawActivePoint(t,e,i,a,r,o,n){if(!r.tooltip){return}if(r.tooltip.group.length>0&&r.tooltip.group.includes(n)==false){return}var l=typeof r.tooltip.index==="number"?r.tooltip.index:r.tooltip.index[r.tooltip.group.indexOf(n)];a.beginPath();if(o.activeType=="hollow"){a.setStrokeStyle(e);a.setFillStyle(r.background);a.setLineWidth(2*r.pix)}else{a.setStrokeStyle("#ffffff");a.setFillStyle(e);a.setLineWidth(1*r.pix)}if(i==="diamond"){t.forEach(function(t,e){if(t!==null&&l==e){a.moveTo(t.x,t.y-4.5);a.lineTo(t.x-4.5,t.y);a.lineTo(t.x,t.y+4.5);a.lineTo(t.x+4.5,t.y);a.lineTo(t.x,t.y-4.5)}})}else if(i==="circle"){t.forEach(function(t,e){if(t!==null&&l==e){a.moveTo(t.x+2.5*r.pix,t.y);a.arc(t.x,t.y,3*r.pix,0,2*Math.PI,false)}})}else if(i==="square"){t.forEach(function(t,e){if(t!==null&&l==e){a.moveTo(t.x-3.5,t.y-3.5);a.rect(t.x-3.5,t.y-3.5,7,7)}})}else if(i==="triangle"){t.forEach(function(t,e){if(t!==null&&l==e){a.moveTo(t.x,t.y-4.5);a.lineTo(t.x-4.5,t.y+4.5);a.lineTo(t.x+4.5,t.y+4.5);a.lineTo(t.x,t.y-4.5)}})}else if(i==="none"){return}a.closePath();a.fill();a.stroke()}function drawRingTitle(t,e,i,a){var r=t.title.fontSize||e.titleFontSize;var o=t.subtitle.fontSize||e.subtitleFontSize;var n=t.title.name||"";var l=t.subtitle.name||"";var x=t.title.color||t.fontColor;var c=t.subtitle.color||t.fontColor;var f=n?r:0;var d=l?o:0;var s=5;if(l){var p=measureText(l,o*t.pix,i);var u=a.x-p/2+(t.subtitle.offsetX||0)*t.pix;var h=a.y+o*t.pix/2+(t.subtitle.offsetY||0)*t.pix;if(n){h+=(f*t.pix+s)/2}i.beginPath();i.setFontSize(o*t.pix);i.setFillStyle(c);i.fillText(l,u,h);i.closePath();i.stroke()}if(n){var g=measureText(n,r*t.pix,i);var y=a.x-g/2+(t.title.offsetX||0);var v=a.y+r*t.pix/2+(t.title.offsetY||0)*t.pix;if(l){v-=(d*t.pix+s)/2}i.beginPath();i.setFontSize(r*t.pix);i.setFillStyle(x);i.fillText(n,y,v);i.closePath();i.stroke()}}function drawPointText(t,o,n,l,s){var h=o.data;var x=o.textOffset?o.textOffset:0;t.forEach(function(t,e){if(t!==null){l.beginPath();var i=o.textSize?o.textSize*s.pix:n.fontSize;l.setFontSize(i);l.setFillStyle(o.textColor||s.fontColor);var a=h[e];if(typeof h[e]==="object"&&h[e]!==null){if(h[e].constructor.toString().indexOf("Array")>-1){a=h[e][1]}else{a=h[e].value}}var r=o.formatter?o.formatter(a,e,o,s):a;l.setTextAlign("center");l.fillText(String(r),t.x,t.y-4+x*s.pix);l.closePath();l.stroke();l.setTextAlign("left")}})}function drawColumePointText(t,n,l,s,h){var x=n.data;var c=n.textOffset?n.textOffset:0;var f=h.extra.column.labelPosition;t.forEach(function(t,e){if(t!==null){s.beginPath();var i=n.textSize?n.textSize*h.pix:l.fontSize;s.setFontSize(i);s.setFillStyle(n.textColor||h.fontColor);var a=x[e];if(typeof x[e]==="object"&&x[e]!==null){if(x[e].constructor.toString().indexOf("Array")>-1){a=x[e][1]}else{a=x[e].value}}var r=n.formatter?n.formatter(a,e,n,h):a;s.setTextAlign("center");var o=t.y-4*h.pix+c*h.pix;if(t.y>n.zeroPoints){o=t.y+c*h.pix+i}if(f=="insideTop"){o=t.y+i+c*h.pix;if(t.y>n.zeroPoints){o=t.y-c*h.pix-4*h.pix}}if(f=="center"){o=t.y+c*h.pix+(h.height-h.area[2]-t.y+i)/2;if(n.zeroPoints<h.height-h.area[2]){o=t.y+c*h.pix+(n.zeroPoints-t.y+i)/2}if(t.y>n.zeroPoints){o=t.y-c*h.pix-(t.y-n.zeroPoints-i)/2}if(h.extra.column.type=="stack"){o=t.y+c*h.pix+(t.y0-t.y+i)/2}}if(f=="bottom"){o=h.height-h.area[2]+c*h.pix-4*h.pix;if(n.zeroPoints<h.height-h.area[2]){o=n.zeroPoints+c*h.pix-4*h.pix}if(t.y>n.zeroPoints){o=n.zeroPoints-c*h.pix+i+2*h.pix}if(h.extra.column.type=="stack"){o=t.y0+c*h.pix-4*h.pix}}s.fillText(String(r),t.x,o);s.closePath();s.stroke();s.setTextAlign("left")}})}function drawBarPointText(t,o,n,l,s){var h=o.data;var e=o.textOffset?o.textOffset:0;t.forEach(function(t,e){if(t!==null){l.beginPath();var i=o.textSize?o.textSize*s.pix:n.fontSize;l.setFontSize(i);l.setFillStyle(o.textColor||s.fontColor);var a=h[e];if(typeof h[e]==="object"&&h[e]!==null){a=h[e].value}var r=o.formatter?o.formatter(a,e,o,s):a;l.setTextAlign("left");l.fillText(String(r),t.x+4*s.pix,t.y+i/2-3);l.closePath();l.stroke()}})}function drawPieText(n,c,f,d,t,l){var p=f.pieChartLinePadding;var u=[];var g=null;var y=n.map(function(t,e){var i=t.formatter?t.formatter(t,e,n,c):util.toFixed(t._proportion_.toFixed(4)*100)+"%";i=t.labelText?t.labelText:i;var a=2*Math.PI-(t._start_+2*Math.PI*t._proportion_/2);if(t._rose_proportion_){a=2*Math.PI-(t._start_+2*Math.PI*t._rose_proportion_/2)}var r=t.color;var o=t._radius_;return{arc:a,text:i,color:r,radius:o,textColor:t.textColor,textSize:t.textSize,labelShow:t.labelShow}});for(let x=0;x<y.length;x++){let t=y[x];let e=Math.cos(t.arc)*(t.radius+p);let i=Math.sin(t.arc)*(t.radius+p);let a=Math.cos(t.arc)*t.radius;let r=Math.sin(t.arc)*t.radius;let o=e>=0?e+f.pieChartTextPadding:e-f.pieChartTextPadding;let n=i;let l=measureText(t.text,t.textSize*c.pix||f.fontSize,d);let s=n;if(g&&util.isSameXCoordinateArea(g.start,{x:o})){if(o>0){s=Math.min(n,g.start.y)}else if(e<0){s=Math.max(n,g.start.y)}else{if(n>0){s=Math.max(n,g.start.y)}else{s=Math.min(n,g.start.y)}}}if(o<0){o-=l}let h={lineStart:{x:a,y:r},lineEnd:{x:e,y:i},start:{x:o,y:s},width:l,height:f.fontSize,text:t.text,color:t.color,textColor:t.textColor,textSize:t.textSize};g=avoidCollision(h,g);u.push(g)}for(let n=0;n<u.length;n++){if(y[n].labelShow===false){continue}let t=u[n];let e=convertCoordinateOrigin(t.lineStart.x,t.lineStart.y,l);let i=convertCoordinateOrigin(t.lineEnd.x,t.lineEnd.y,l);let a=convertCoordinateOrigin(t.start.x,t.start.y,l);d.setLineWidth(1*c.pix);d.setFontSize(t.textSize*c.pix||f.fontSize);d.beginPath();d.setStrokeStyle(t.color);d.setFillStyle(t.color);d.moveTo(e.x,e.y);let r=t.start.x<0?a.x+t.width:a.x;let o=t.start.x<0?a.x-5:a.x+5;d.quadraticCurveTo(i.x,i.y,r,a.y);d.moveTo(e.x,e.y);d.stroke();d.closePath();d.beginPath();d.moveTo(a.x+t.width,a.y);d.arc(r,a.y,2*c.pix,0,2*Math.PI);d.closePath();d.fill();d.beginPath();d.setFontSize(t.textSize*c.pix||f.fontSize);d.setFillStyle(t.textColor||c.fontColor);d.fillText(t.text,o,a.y+3);d.closePath();d.stroke();d.closePath()}}function drawToolTipSplitLine(r,o,n,l){var s=o.extra.tooltip||{};s.gridType=s.gridType==undefined?"solid":s.gridType;s.dashLength=s.dashLength==undefined?4:s.dashLength;var t=o.area[0];var h=o.height-o.area[2];if(s.gridType=="dash"){l.setLineDash([s.dashLength,s.dashLength])}l.setStrokeStyle(s.gridColor||"#cccccc");l.setLineWidth(1*o.pix);l.beginPath();l.moveTo(r,t);l.lineTo(r,h);l.stroke();l.setLineDash([]);if(s.xAxisLabel){let t=o.categories[o.tooltip.index];l.setFontSize(n.fontSize);let e=measureText(t,n.fontSize,l);let i=r-.5*e;let a=h+2*o.pix;l.beginPath();l.setFillStyle(hexToRgb(s.labelBgColor||n.toolTipBackground,s.labelBgOpacity||n.toolTipOpacity));l.setStrokeStyle(s.labelBgColor||n.toolTipBackground);l.setLineWidth(1*o.pix);l.rect(i-s.boxPadding*o.pix,a,e+2*s.boxPadding*o.pix,n.fontSize+2*s.boxPadding*o.pix);l.closePath();l.stroke();l.fill();l.beginPath();l.setFontSize(n.fontSize);l.setFillStyle(s.labelFontColor||o.fontColor);l.fillText(String(t),i,a+s.boxPadding*o.pix+n.fontSize);l.closePath();l.stroke()}}function drawMarkLine(h,t,x){let e=assign({},{type:"solid",dashLength:4,data:[]},h.extra.markLine);let i=h.area[3];let a=h.width-h.area[1];let r=calMarkLineData(e.data,h);for(let t=0;t<r.length;t++){let s=assign({},{lineColor:"#DE4A42",showLabel:false,labelFontSize:13,labelPadding:6,labelFontColor:"#666666",labelBgColor:"#DFE8FF",labelBgOpacity:.8,labelAlign:"left",labelOffsetX:0,labelOffsetY:0},r[t]);if(e.type=="dash"){x.setLineDash([e.dashLength,e.dashLength])}x.setStrokeStyle(s.lineColor);x.setLineWidth(1*h.pix);x.beginPath();x.moveTo(i,s.y);x.lineTo(a,s.y);x.stroke();x.setLineDash([]);if(s.showLabel){let t=s.labelFontSize*h.pix;let e=s.labelText?s.labelText:s.value;x.setFontSize(t);let i=measureText(e,t,x);let a=i+s.labelPadding*h.pix*2;let r=s.labelAlign=="left"?h.area[3]-a:h.width-h.area[1];r+=s.labelOffsetX;let o=s.y-.5*t-s.labelPadding*h.pix;o+=s.labelOffsetY;let n=r+s.labelPadding*h.pix;let l=s.y;x.setFillStyle(hexToRgb(s.labelBgColor,s.labelBgOpacity));x.setStrokeStyle(s.labelBgColor);x.setLineWidth(1*h.pix);x.beginPath();x.rect(r,o,a,t+2*s.labelPadding*h.pix);x.closePath();x.stroke();x.fill();x.setFontSize(t);x.setTextAlign("left");x.setFillStyle(s.labelFontColor);x.fillText(String(e),n,o+t+s.labelPadding*h.pix/2);x.stroke();x.setTextAlign("left")}}}function drawToolTipHorizentalLine(f,d,p,t,e){var u=assign({},{gridType:"solid",dashLength:4},f.extra.tooltip);var i=f.area[3];var a=f.width-f.area[1];if(u.gridType=="dash"){p.setLineDash([u.dashLength,u.dashLength])}p.setStrokeStyle(u.gridColor||"#cccccc");p.setLineWidth(1*f.pix);p.beginPath();p.moveTo(i,f.tooltip.offset.y);p.lineTo(a,f.tooltip.offset.y);p.stroke();p.setLineDash([]);if(u.yAxisLabel){let l=u.boxPadding*f.pix;let s=calTooltipYAxisData(f.tooltip.offset.y,f.series,f,d,t);let h=f.chartData.yAxisData.yAxisWidth;let x=f.area[3];let c=f.width-f.area[1];for(let n=0;n<s.length;n++){p.setFontSize(u.fontSize*f.pix);let t=measureText(s[n],u.fontSize*f.pix,p);let e,i,a;if(h[n].position=="left"){e=x-(t+l*2)-2*f.pix;i=Math.max(e,e+t+l*2)}else{e=c+2*f.pix;i=Math.max(e+h[n].width,e+t+l*2)}a=i-e;let r=e+(a-t)/2;let o=f.tooltip.offset.y;p.beginPath();p.setFillStyle(hexToRgb(u.labelBgColor||d.toolTipBackground,u.labelBgOpacity||d.toolTipOpacity));p.setStrokeStyle(u.labelBgColor||d.toolTipBackground);p.setLineWidth(1*f.pix);p.rect(e,o-.5*d.fontSize-l,a,d.fontSize+2*l);p.closePath();p.stroke();p.fill();p.beginPath();p.setFontSize(d.fontSize);p.setFillStyle(u.labelFontColor||f.fontColor);p.fillText(s[n],r,o+.5*d.fontSize);p.closePath();p.stroke();if(h[n].position=="left"){x-=h[n].width+f.yAxis.padding*f.pix}else{c+=h[n].width+f.yAxis.padding*f.pix}}}}function drawToolTipSplitArea(t,e,i,a,r){var o=assign({},{activeBgColor:"#000000",activeBgOpacity:.08,activeWidth:r},e.extra.column);o.activeWidth=o.activeWidth>r?r:o.activeWidth;var n=e.area[0];var l=e.height-e.area[2];a.beginPath();a.setFillStyle(hexToRgb(o.activeBgColor,o.activeBgOpacity));a.rect(t-o.activeWidth/2,n,o.activeWidth,l-n);a.closePath();a.fill();a.setFillStyle("#FFFFFF")}function drawBarToolTipSplitArea(t,e,i,a,r){var o=assign({},{activeBgColor:"#000000",activeBgOpacity:.08},e.extra.bar);var n=e.area[3];var l=e.width-e.area[1];a.beginPath();a.setFillStyle(hexToRgb(o.activeBgColor,o.activeBgOpacity));a.rect(n,t-r/2,l-n,r);a.closePath();a.fill();a.setFillStyle("#FFFFFF")}function drawToolTip(e,r,o,i,n,a,d){var l=assign({},{showBox:true,showArrow:true,showCategory:false,bgColor:"#000000",bgOpacity:.7,borderColor:"#000000",borderWidth:0,borderRadius:0,borderOpacity:.7,boxPadding:3,fontColor:"#FFFFFF",fontSize:13,lineHeight:20,legendShow:true,legendShape:"auto",splitLine:true},o.extra.tooltip);if(l.showCategory==true&&o.categories){e.unshift({text:o.categories[o.tooltip.index],color:null})}var s=l.fontSize*o.pix;var p=l.lineHeight*o.pix;var h=l.boxPadding*o.pix;var x=s;var u=5*o.pix;if(l.legendShow==false){x=0;u=0}var c=l.showArrow?8*o.pix:0;var g=false;if(o.type=="line"||o.type=="mount"||o.type=="area"||o.type=="candle"||o.type=="mix"){if(l.splitLine==true){drawToolTipSplitLine(o.tooltip.offset.x,o,i,n)}}r=assign({x:0,y:0},r);r.y-=8*o.pix;var y=e.map(function(t){return measureText(t.text,s,n)});var f=x+u+4*h+Math.max.apply(null,y);var v=2*h+e.length*p;if(l.showBox==false){return}if(r.x-Math.abs(o._scrollDistance_||0)+c+f>o.width){g=true}if(v+r.y>o.height){r.y=o.height-v}n.beginPath();n.setFillStyle(hexToRgb(l.bgColor,l.bgOpacity));n.setLineWidth(l.borderWidth*o.pix);n.setStrokeStyle(hexToRgb(l.borderColor,l.borderOpacity));var t=l.borderRadius;if(g){if(f+c>o.width){r.x=o.width+Math.abs(o._scrollDistance_||0)+c+(f-o.width)}if(f>r.x){r.x=o.width+Math.abs(o._scrollDistance_||0)+c+(f-o.width)}if(l.showArrow){n.moveTo(r.x,r.y+10*o.pix);n.lineTo(r.x-c,r.y+10*o.pix+5*o.pix)}n.arc(r.x-c-t,r.y+v-t,t,0,Math.PI/2,false);n.arc(r.x-c-Math.round(f)+t,r.y+v-t,t,Math.PI/2,Math.PI,false);n.arc(r.x-c-Math.round(f)+t,r.y+t,t,-Math.PI,-Math.PI/2,false);n.arc(r.x-c-t,r.y+t,t,-Math.PI/2,0,false);if(l.showArrow){n.lineTo(r.x-c,r.y+10*o.pix-5*o.pix);n.lineTo(r.x,r.y+10*o.pix)}}else{if(l.showArrow){n.moveTo(r.x,r.y+10*o.pix);n.lineTo(r.x+c,r.y+10*o.pix-5*o.pix)}n.arc(r.x+c+t,r.y+t,t,-Math.PI,-Math.PI/2,false);n.arc(r.x+c+Math.round(f)-t,r.y+t,t,-Math.PI/2,0,false);n.arc(r.x+c+Math.round(f)-t,r.y+v-t,t,0,Math.PI/2,false);n.arc(r.x+c+t,r.y+v-t,t,Math.PI/2,Math.PI,false);if(l.showArrow){n.lineTo(r.x+c,r.y+10*o.pix+5*o.pix);n.lineTo(r.x,r.y+10*o.pix)}}n.closePath();n.fill();if(l.borderWidth>0){n.stroke()}if(l.legendShow){e.forEach(function(t,e){if(t.color!==null){n.beginPath();n.setFillStyle(t.color);var i=r.x+c+2*h;var a=r.y+(p-s)/2+p*e+h+1;if(g){i=r.x-f-c+2*h}switch(t.legendShape){case"line":n.moveTo(i,a+.5*x-2*o.pix);n.fillRect(i,a+.5*x-2*o.pix,x,4*o.pix);break;case"triangle":n.moveTo(i+7.5*o.pix,a+.5*x-5*o.pix);n.lineTo(i+2.5*o.pix,a+.5*x+5*o.pix);n.lineTo(i+12.5*o.pix,a+.5*x+5*o.pix);n.lineTo(i+7.5*o.pix,a+.5*x-5*o.pix);break;case"diamond":n.moveTo(i+7.5*o.pix,a+.5*x-5*o.pix);n.lineTo(i+2.5*o.pix,a+.5*x);n.lineTo(i+7.5*o.pix,a+.5*x+5*o.pix);n.lineTo(i+12.5*o.pix,a+.5*x);n.lineTo(i+7.5*o.pix,a+.5*x-5*o.pix);break;case"circle":n.moveTo(i+7.5*o.pix,a+.5*x);n.arc(i+7.5*o.pix,a+.5*x,5*o.pix,0,2*Math.PI);break;case"rect":n.moveTo(i,a+.5*x-5*o.pix);n.fillRect(i,a+.5*x-5*o.pix,15*o.pix,10*o.pix);break;case"square":n.moveTo(i+2*o.pix,a+.5*x-5*o.pix);n.fillRect(i+2*o.pix,a+.5*x-5*o.pix,10*o.pix,10*o.pix);break;default:n.moveTo(i,a+.5*x-5*o.pix);n.fillRect(i,a+.5*x-5*o.pix,15*o.pix,10*o.pix)}n.closePath();n.fill()}})}e.forEach(function(t,e){var i=r.x+c+2*h+x+u;if(g){i=r.x-f-c+2*h+x+u}var a=r.y+p*e+(p-s)/2-1+h+s;n.beginPath();n.setFontSize(s);n.setTextBaseline("normal");n.setFillStyle(l.fontColor);n.fillText(t.text,i,a);n.closePath();n.stroke()})}function drawColumnDataPoints(b,T,A,S){let w=arguments.length>4&&arguments[4]!==undefined?arguments[4]:1;let t=T.chartData.xAxisData,P=t.xAxisPoints,C=t.eachSpacing;let D=assign({},{type:"group",width:C/2,meterBorder:4,meterFillColor:"#FFFFFF",barBorderCircle:false,barBorderRadius:[],seriesGap:2,linearType:"none",linearOpacity:1,customColor:[],colorStop:0,labelPosition:"outside"},T.extra.column);let M=[];S.save();let _=-2;let L=P.length+2;if(T._scrollDistance_&&T._scrollDistance_!==0&&T.enableScroll===true){S.translate(T._scrollDistance_,0);_=Math.floor(-T._scrollDistance_/C)-2;L=_+T.xAxis.itemCount+4}if(T.tooltip&&T.tooltip.textList&&T.tooltip.textList.length&&w===1){drawToolTipSplitArea(T.tooltip.offset.x,T,A,S,C)}D.customColor=fillCustomColor(D.linearType,D.customColor,b,A);b.forEach(function(i,a){let e,t,o;e=[].concat(T.chartData.yAxisData.ranges[i.index]);t=e.pop();o=e.shift();let f=T.height-T.area[0]-T.area[2];let d=f*(0-t)/(o-t);let n=T.height-Math.round(d)-T.area[2];i.zeroPoints=n;var p=i.data;switch(D.type){case"group":var r=getColumnDataPoints(p,t,o,P,C,T,A,n,w);var u=getStackDataPoints(p,t,o,P,C,T,A,a,b,w);M.push(u);r=fixColumeData(r,C,b.length,a,A,T);for(let t=0;t<r.length;t++){let o=r[t];if(o!==null&&t>_&&t<L){var l=o.x-o.width/2;var s=T.height-o.y-T.area[2];S.beginPath();var g=o.color||i.color;var y=o.color||i.color;if(D.linearType!=="none"){var v=S.createLinearGradient(l,o.y,l,n);if(D.linearType=="opacity"){v.addColorStop(0,hexToRgb(g,D.linearOpacity));v.addColorStop(1,hexToRgb(g,1))}else{v.addColorStop(0,hexToRgb(D.customColor[i.linearIndex],D.linearOpacity));v.addColorStop(D.colorStop,hexToRgb(D.customColor[i.linearIndex],D.linearOpacity));v.addColorStop(1,hexToRgb(g,1))}g=v}if(D.barBorderRadius&&D.barBorderRadius.length===4||D.barBorderCircle===true){const h=l;const x=o.y>n?n:o.y;const c=o.width;const s=Math.abs(n-o.y);if(D.barBorderCircle){D.barBorderRadius=[c/2,c/2,0,0]}if(o.y>n){D.barBorderRadius=[0,0,c/2,c/2]}let[t,e,i,a]=D.barBorderRadius;let r=Math.min(c/2,s/2);t=t>r?r:t;e=e>r?r:e;i=i>r?r:i;a=a>r?r:a;t=t<0?0:t;e=e<0?0:e;i=i<0?0:i;a=a<0?0:a;S.arc(h+t,x+t,t,-Math.PI,-Math.PI/2);S.arc(h+c-e,x+e,e,-Math.PI/2,0);S.arc(h+c-i,x+s-i,i,0,Math.PI/2);S.arc(h+a,x+s-a,a,Math.PI/2,Math.PI)}else{S.moveTo(l,o.y);S.lineTo(l+o.width,o.y);S.lineTo(l+o.width,n);S.lineTo(l,n);S.lineTo(l,o.y);S.setLineWidth(1);S.setStrokeStyle(y)}S.setFillStyle(g);S.closePath();S.fill()}};break;case"stack":var r=getStackDataPoints(p,t,o,P,C,T,A,a,b,w);M.push(r);r=fixColumeStackData(r,C,b.length,a,A,T,b);for(let e=0;e<r.length;e++){let t=r[e];if(t!==null&&e>_&&e<L){S.beginPath();var g=t.color||i.color;var l=t.x-t.width/2+1;var s=T.height-t.y-T.area[2];var m=T.height-t.y0-T.area[2];if(a>0){s-=m}S.setFillStyle(g);S.moveTo(l,t.y);S.fillRect(l,t.y,t.width,s);S.closePath();S.fill()}};break;case"meter":var r=getDataPoints(p,t,o,P,C,T,A,w);M.push(r);r=fixColumeMeterData(r,C,b.length,a,A,T,D.meterBorder);for(let t=0;t<r.length;t++){let o=r[t];if(o!==null&&t>_&&t<L){S.beginPath();if(a==0&&D.meterBorder>0){S.setStrokeStyle(i.color);S.setLineWidth(D.meterBorder*T.pix)}if(a==0){S.setFillStyle(D.meterFillColor)}else{S.setFillStyle(o.color||i.color)}var l=o.x-o.width/2;var s=T.height-o.y-T.area[2];if(D.barBorderRadius&&D.barBorderRadius.length===4||D.barBorderCircle===true){const h=l;const x=o.y;const c=o.width;const s=n-o.y;if(D.barBorderCircle){D.barBorderRadius=[c/2,c/2,0,0]}let[t,e,i,a]=D.barBorderRadius;let r=Math.min(c/2,s/2);t=t>r?r:t;e=e>r?r:e;i=i>r?r:i;a=a>r?r:a;t=t<0?0:t;e=e<0?0:e;i=i<0?0:i;a=a<0?0:a;S.arc(h+t,x+t,t,-Math.PI,-Math.PI/2);S.arc(h+c-e,x+e,e,-Math.PI/2,0);S.arc(h+c-i,x+s-i,i,0,Math.PI/2);S.arc(h+a,x+s-a,a,Math.PI/2,Math.PI);S.fill()}else{S.moveTo(l,o.y);S.lineTo(l+o.width,o.y);S.lineTo(l+o.width,n);S.lineTo(l,n);S.lineTo(l,o.y);S.fill()}if(a==0&&D.meterBorder>0){S.closePath();S.stroke()}}}break}});if(T.dataLabel!==false&&w===1){b.forEach(function(t,e){let i,a,r;i=[].concat(T.chartData.yAxisData.ranges[t.index]);a=i.pop();r=i.shift();var o=t.data;switch(D.type){case"group":var n=getColumnDataPoints(o,a,r,P,C,T,A,w);n=fixColumeData(n,C,b.length,e,A,T);drawColumePointText(n,t,A,S,T);break;case"stack":var n=getStackDataPoints(o,a,r,P,C,T,A,e,b,w);drawColumePointText(n,t,A,S,T);break;case"meter":var n=getDataPoints(o,a,r,P,C,T,A,w);drawColumePointText(n,t,A,S,T);break}})}S.restore();return{xAxisPoints:P,calPoints:M,eachSpacing:C}}function drawBarDataPoints(y,v,m,b){let T=arguments.length>4&&arguments[4]!==undefined?arguments[4]:1;let A=[];let S=(v.height-v.area[0]-v.area[2])/v.categories.length;for(let t=0;t<v.categories.length;t++){A.push(v.area[0]+S/2+S*t)}let w=assign({},{type:"group",width:S/2,meterBorder:4,meterFillColor:"#FFFFFF",barBorderCircle:false,barBorderRadius:[],seriesGap:2,linearType:"none",linearOpacity:1,customColor:[],colorStop:0},v.extra.bar);let P=[];b.save();let C=-2;let D=A.length+2;if(v.tooltip&&v.tooltip.textList&&v.tooltip.textList.length&&T===1){drawBarToolTipSplitArea(v.tooltip.offset.y,v,m,b,S)}w.customColor=fillCustomColor(w.linearType,w.customColor,y,m);y.forEach(function(i,t){let o,e,c;o=[].concat(v.chartData.xAxisData.ranges);c=o.pop();e=o.shift();var f=i.data;switch(w.type){case"group":var a=getBarDataPoints(f,e,c,A,S,v,m,T);var d=getBarStackDataPoints(f,e,c,A,S,v,m,t,y,T);P.push(d);a=fixBarData(a,S,y.length,t,m,v);for(let t=0;t<a.length;t++){let o=a[t];if(o!==null&&t>C&&t<D){var n=v.area[3];var r=o.y-o.width/2;var p=o.height;b.beginPath();var l=o.color||i.color;var u=o.color||i.color;if(w.linearType!=="none"){var s=b.createLinearGradient(n,o.y,o.x,o.y);if(w.linearType=="opacity"){s.addColorStop(0,hexToRgb(l,w.linearOpacity));s.addColorStop(1,hexToRgb(l,1))}else{s.addColorStop(0,hexToRgb(w.customColor[i.linearIndex],w.linearOpacity));s.addColorStop(w.colorStop,hexToRgb(w.customColor[i.linearIndex],w.linearOpacity));s.addColorStop(1,hexToRgb(l,1))}l=s}if(w.barBorderRadius&&w.barBorderRadius.length===4||w.barBorderCircle===true){const g=n;const h=o.width;const x=o.y-o.width/2;const p=o.height;if(w.barBorderCircle){w.barBorderRadius=[h/2,h/2,0,0]}let[t,e,i,a]=w.barBorderRadius;let r=Math.min(h/2,p/2);t=t>r?r:t;e=e>r?r:e;i=i>r?r:i;a=a>r?r:a;t=t<0?0:t;e=e<0?0:e;i=i<0?0:i;a=a<0?0:a;b.arc(g+a,x+a,a,-Math.PI,-Math.PI/2);b.arc(o.x-t,x+t,t,-Math.PI/2,0);b.arc(o.x-e,x+h-e,e,0,Math.PI/2);b.arc(g+i,x+h-i,i,Math.PI/2,Math.PI)}else{b.moveTo(n,r);b.lineTo(o.x,r);b.lineTo(o.x,r+o.width);b.lineTo(n,r+o.width);b.lineTo(n,r);b.setLineWidth(1);b.setStrokeStyle(u)}b.setFillStyle(l);b.closePath();b.fill()}};break;case"stack":var a=getBarStackDataPoints(f,e,c,A,S,v,m,t,y,T);P.push(a);a=fixBarStackData(a,S,y.length,t,m,v,y);for(let e=0;e<a.length;e++){let t=a[e];if(t!==null&&e>C&&e<D){b.beginPath();var l=t.color||i.color;var n=t.x0;b.setFillStyle(l);b.moveTo(n,t.y-t.width/2);b.fillRect(n,t.y-t.width/2,t.height,t.width);b.closePath();b.fill()}};break}});if(v.dataLabel!==false&&T===1){y.forEach(function(t,e){let i,a,r;i=[].concat(v.chartData.xAxisData.ranges);r=i.pop();a=i.shift();var o=t.data;switch(w.type){case"group":var n=getBarDataPoints(o,a,r,A,S,v,m,T);n=fixBarData(n,S,y.length,e,m,v);drawBarPointText(n,t,m,b,v);break;case"stack":var n=getBarStackDataPoints(o,a,r,A,S,v,m,e,y,T);drawBarPointText(n,t,m,b,v);break}})}return{yAxisPoints:A,calPoints:P,eachSpacing:S}}function drawLineDataPoints(t,c,f,d){var p=arguments.length>4&&arguments[4]!==undefined?arguments[4]:1;var u=assign({},{type:"straight",width:2,activeType:"none",linearType:"none",onShadow:false,animation:"vertical"},c.extra.line);u.width*=c.pix;let e=c.chartData.xAxisData,g=e.xAxisPoints,y=e.eachSpacing;var b=[];d.save();let v=0;let m=c.width+y;if(c._scrollDistance_&&c._scrollDistance_!==0&&c.enableScroll===true){d.translate(c._scrollDistance_,0);v=-c._scrollDistance_-y*2+c.area[3];m=v+(c.xAxis.itemCount+4)*y}t.forEach(function(e,x){d.beginPath();d.setStrokeStyle(e.color);d.moveTo(-1e4,-1e4);d.lineTo(-10001,-10001);d.stroke();let t,i,a;t=[].concat(c.chartData.yAxisData.ranges[e.index]);i=t.pop();a=t.shift();var r=e.data;var o=getLineDataPoints(r,i,a,g,y,c,f,u,p);b.push(o);var n=splitPoints(o,e);if(e.lineType=="dash"){let t=e.dashLength?e.dashLength:8;t*=c.pix;d.setLineDash([t,t])}d.beginPath();var l=e.color;if(u.linearType!=="none"&&e.linearColor&&e.linearColor.length>0){var s=d.createLinearGradient(c.chartData.xAxisData.startX,c.height/2,c.chartData.xAxisData.endX,c.height/2);for(var h=0;h<e.linearColor.length;h++){s.addColorStop(e.linearColor[h][0],hexToRgb(e.linearColor[h][1],1))}l=s}d.setStrokeStyle(l);if(u.onShadow==true&&e.setShadow&&e.setShadow.length>0){d.setShadow(e.setShadow[0],e.setShadow[1],e.setShadow[2],e.setShadow[3])}else{d.setShadow(0,0,0,"rgba(0,0,0,0)")}d.setLineWidth(u.width);n.forEach(function(a,t){if(a.length===1){d.moveTo(a[0].x,a[0].y)}else{d.moveTo(a[0].x,a[0].y);let i=0;if(u.type==="curve"){for(let e=0;e<a.length;e++){let t=a[e];if(i==0&&t.x>v){d.moveTo(t.x,t.y);i=1}if(e>0&&t.x>v&&t.x<m){var r=createCurveControlPoints(a,e-1);d.bezierCurveTo(r.ctrA.x,r.ctrA.y,r.ctrB.x,r.ctrB.y,t.x,t.y)}}}if(u.type==="straight"){for(let e=0;e<a.length;e++){let t=a[e];if(i==0&&t.x>v){d.moveTo(t.x,t.y);i=1}if(e>0&&t.x>v&&t.x<m){d.lineTo(t.x,t.y)}}}if(u.type==="step"){for(let e=0;e<a.length;e++){let t=a[e];if(i==0&&t.x>v){d.moveTo(t.x,t.y);i=1}if(e>0&&t.x>v&&t.x<m){d.lineTo(t.x,a[e-1].y);d.lineTo(t.x,t.y)}}}d.moveTo(a[0].x,a[0].y)}});d.stroke();d.setLineDash([]);if(c.dataPointShape!==false){drawPointShape(o,e.color,e.pointShape,d,c)}drawActivePoint(o,e.color,e.pointShape,d,c,u)});if(c.dataLabel!==false&&p===1){t.forEach(function(t,e){let i,a,r;i=[].concat(c.chartData.yAxisData.ranges[t.index]);a=i.pop();r=i.shift();var o=t.data;var n=getDataPoints(o,a,r,g,y,c,f,p);drawPointText(n,t,f,d,c)})}d.restore();return{xAxisPoints:g,calPoints:b,eachSpacing:y}}function drawMixDataPoints(t,v,m,b){let D=arguments.length>4&&arguments[4]!==undefined?arguments[4]:1;let e=v.chartData.xAxisData,T=e.xAxisPoints,A=e.eachSpacing;let S=assign({},{width:A/2,barBorderCircle:false,barBorderRadius:[],seriesGap:2,linearType:"none",linearOpacity:1,customColor:[],colorStop:0},v.extra.mix.column);let w=assign({},{opacity:.2,gradient:false},v.extra.mix.area);let M=assign({},{width:2},v.extra.mix.line);let _=v.height-v.area[2];let L=[];var F=0;var k=0;t.forEach(function(t,e){if(t.type=="column"){k+=1}});b.save();let R=-2;let I=T.length+2;let P=0;let C=v.width+A;if(v._scrollDistance_&&v._scrollDistance_!==0&&v.enableScroll===true){b.translate(v._scrollDistance_,0);R=Math.floor(-v._scrollDistance_/A)-2;I=R+v.xAxis.itemCount+4;P=-v._scrollDistance_-A*2+v.area[3];C=P+(v.xAxis.itemCount+4)*A}S.customColor=fillCustomColor(S.linearType,S.customColor,t,m);t.forEach(function(n,t){let o,f,d;o=[].concat(v.chartData.yAxisData.ranges[n.index]);f=o.pop();d=o.shift();var p=n.data;var i=getDataPoints(p,f,d,T,A,v,m,D);L.push(i);if(n.type=="column"){i=fixColumeData(i,A,k,F,m,v);for(let t=0;t<i.length;t++){let o=i[t];if(o!==null&&t>R&&t<I){var l=o.x-o.width/2;var s=v.height-o.y-v.area[2];b.beginPath();var e=o.color||n.color;var u=o.color||n.color;if(S.linearType!=="none"){var a=b.createLinearGradient(l,o.y,l,v.height-v.area[2]);if(S.linearType=="opacity"){a.addColorStop(0,hexToRgb(e,S.linearOpacity));a.addColorStop(1,hexToRgb(e,1))}else{a.addColorStop(0,hexToRgb(S.customColor[n.linearIndex],S.linearOpacity));a.addColorStop(S.colorStop,hexToRgb(S.customColor[n.linearIndex],S.linearOpacity));a.addColorStop(1,hexToRgb(e,1))}e=a}if(S.barBorderRadius&&S.barBorderRadius.length===4||S.barBorderCircle){const h=l;const x=o.y;const c=o.width;const s=v.height-v.area[2]-o.y;if(S.barBorderCircle){S.barBorderRadius=[c/2,c/2,0,0]}let[t,e,i,a]=S.barBorderRadius;let r=Math.min(c/2,s/2);t=t>r?r:t;e=e>r?r:e;i=i>r?r:i;a=a>r?r:a;t=t<0?0:t;e=e<0?0:e;i=i<0?0:i;a=a<0?0:a;b.arc(h+t,x+t,t,-Math.PI,-Math.PI/2);b.arc(h+c-e,x+e,e,-Math.PI/2,0);b.arc(h+c-i,x+s-i,i,0,Math.PI/2);b.arc(h+a,x+s-a,a,Math.PI/2,Math.PI)}else{b.moveTo(l,o.y);b.lineTo(l+o.width,o.y);b.lineTo(l+o.width,v.height-v.area[2]);b.lineTo(l,v.height-v.area[2]);b.lineTo(l,o.y);b.setLineWidth(1);b.setStrokeStyle(u)}b.setFillStyle(e);b.closePath();b.fill()}}F+=1}if(n.type=="area"){let e=splitPoints(i,n);for(let t=0;t<e.length;t++){let a=e[t];b.beginPath();b.setStrokeStyle(n.color);b.setStrokeStyle(hexToRgb(n.color,w.opacity));if(w.gradient){let t=b.createLinearGradient(0,v.area[0],0,v.height-v.area[2]);t.addColorStop("0",hexToRgb(n.color,w.opacity));t.addColorStop("1.0",hexToRgb("#FFFFFF",.1));b.setFillStyle(t)}else{b.setFillStyle(hexToRgb(n.color,w.opacity))}b.setLineWidth(2*v.pix);if(a.length>1){var r=a[0];let t=a[a.length-1];b.moveTo(r.x,r.y);let i=0;if(n.style==="curve"){for(let e=0;e<a.length;e++){let t=a[e];if(i==0&&t.x>P){b.moveTo(t.x,t.y);i=1}if(e>0&&t.x>P&&t.x<C){var g=createCurveControlPoints(a,e-1);b.bezierCurveTo(g.ctrA.x,g.ctrA.y,g.ctrB.x,g.ctrB.y,t.x,t.y)}}}else{for(let e=0;e<a.length;e++){let t=a[e];if(i==0&&t.x>P){b.moveTo(t.x,t.y);i=1}if(e>0&&t.x>P&&t.x<C){b.lineTo(t.x,t.y)}}}b.lineTo(t.x,_);b.lineTo(r.x,_);b.lineTo(r.x,r.y)}else{let t=a[0];b.moveTo(t.x-A/2,t.y)}b.closePath();b.fill()}}if(n.type=="line"){var y=splitPoints(i,n);y.forEach(function(a,t){if(n.lineType=="dash"){let t=n.dashLength?n.dashLength:8;t*=v.pix;b.setLineDash([t,t])}b.beginPath();b.setStrokeStyle(n.color);b.setLineWidth(M.width*v.pix);if(a.length===1){b.moveTo(a[0].x,a[0].y)}else{b.moveTo(a[0].x,a[0].y);let i=0;if(n.style=="curve"){for(let e=0;e<a.length;e++){let t=a[e];if(i==0&&t.x>P){b.moveTo(t.x,t.y);i=1}if(e>0&&t.x>P&&t.x<C){var r=createCurveControlPoints(a,e-1);b.bezierCurveTo(r.ctrA.x,r.ctrA.y,r.ctrB.x,r.ctrB.y,t.x,t.y)}}}else{for(let e=0;e<a.length;e++){let t=a[e];if(i==0&&t.x>P){b.moveTo(t.x,t.y);i=1}if(e>0&&t.x>P&&t.x<C){b.lineTo(t.x,t.y)}}}b.moveTo(a[0].x,a[0].y)}b.stroke();b.setLineDash([])})}if(n.type=="point"){n.addPoint=true}if(n.addPoint==true&&n.type!=="column"){drawPointShape(i,n.color,n.pointShape,b,v)}});if(v.dataLabel!==false&&D===1){var F=0;t.forEach(function(t,e){let i,a,r;i=[].concat(v.chartData.yAxisData.ranges[t.index]);a=i.pop();r=i.shift();var o=t.data;var n=getDataPoints(o,a,r,T,A,v,m,D);if(t.type!=="column"){drawPointText(n,t,m,b,v)}else{n=fixColumeData(n,A,k,F,m,v);drawPointText(n,t,m,b,v);F+=1}})}b.restore();return{xAxisPoints:T,calPoints:L,eachSpacing:A}}function drawToolTipBridge(t,e,i,a,r,o){var n=t.extra.tooltip||{};if(n.horizentalLine&&t.tooltip&&a===1&&(t.type=="line"||t.type=="area"||t.type=="column"||t.type=="mount"||t.type=="candle"||t.type=="mix")){drawToolTipHorizentalLine(t,e,i,r,o)}i.save();if(t._scrollDistance_&&t._scrollDistance_!==0&&t.enableScroll===true){i.translate(t._scrollDistance_,0)}if(t.tooltip&&t.tooltip.textList&&t.tooltip.textList.length&&a===1){drawToolTip(t.tooltip.textList,t.tooltip.offset,t,e,i,r,o)}i.restore()}function drawXAxis(r,h,x,c){let e=h.chartData.xAxisData,f=e.xAxisPoints,t=e.startX,i=e.endX,d=e.eachSpacing;var p="center";if(h.type=="bar"||h.type=="line"||h.type=="area"||h.type=="scatter"||h.type=="bubble"){p=h.xAxis.boundaryGap}var u=h.height-h.area[2];var a=h.area[0];if(h.enableScroll&&h.xAxis.scrollShow){var o=h.height-h.area[2]+x.xAxisHeight;var n=i-t;var l=d*(f.length-1);if(h.type=="mount"&&h.extra&&h.extra.mount&&h.extra.mount.widthRatio&&h.extra.mount.widthRatio>1){if(h.extra.mount.widthRatio>2)h.extra.mount.widthRatio=2;l+=(h.extra.mount.widthRatio-1)*d}var s=n*n/l;var y=0;if(h._scrollDistance_){y=-h._scrollDistance_*n/l}c.beginPath();c.setLineCap("round");c.setLineWidth(6*h.pix);c.setStrokeStyle(h.xAxis.scrollBackgroundColor||"#EFEBEF");c.moveTo(t,o);c.lineTo(i,o);c.stroke();c.closePath();c.beginPath();c.setLineCap("round");c.setLineWidth(6*h.pix);c.setStrokeStyle(h.xAxis.scrollColor||"#A6A6A6");c.moveTo(t+y,o);c.lineTo(t+y+s,o);c.stroke();c.closePath();c.setLineCap("butt")}c.save();if(h._scrollDistance_&&h._scrollDistance_!==0){c.translate(h._scrollDistance_,0)}if(h.xAxis.calibration===true){c.setStrokeStyle(h.xAxis.gridColor||"#cccccc");c.setLineCap("butt");c.setLineWidth(1*h.pix);f.forEach(function(t,e){if(e>0){c.beginPath();c.moveTo(t-d/2,u);c.lineTo(t-d/2,u+3*h.pix);c.closePath();c.stroke()}})}if(h.xAxis.disableGrid!==true){c.setStrokeStyle(h.xAxis.gridColor||"#cccccc");c.setLineCap("butt");c.setLineWidth(1*h.pix);if(h.xAxis.gridType=="dash"){c.setLineDash([h.xAxis.dashLength*h.pix,h.xAxis.dashLength*h.pix])}h.xAxis.gridEval=h.xAxis.gridEval||1;f.forEach(function(t,e){if(e%h.xAxis.gridEval==0){c.beginPath();c.moveTo(t,u);c.lineTo(t,a);c.stroke()}});c.setLineDash([])}if(h.xAxis.disabled!==true){let t=r.length;if(h.xAxis.labelCount){if(h.xAxis.itemCount){t=Math.ceil(r.length/h.xAxis.itemCount*h.xAxis.labelCount)}else{t=h.xAxis.labelCount}t-=1}let e=Math.ceil(r.length/t);let i=[];let a=r.length;for(let t=0;t<a;t++){if(t%e!==0){i.push("")}else{i.push(r[t])}}i[a-1]=r[a-1];var g=h.xAxis.fontSize*h.pix||x.fontSize;if(x._xAxisTextAngle_===0){i.forEach(function(t,e){var i=h.xAxis.formatter?h.xAxis.formatter(t,e,h):t;var a=-measureText(String(i),g,c)/2;if(p=="center"){a+=d/2}var r=0;if(h.xAxis.scrollShow){r=6*h.pix}var o=h._scrollDistance_||0;var n=p=="center"?f[e]+d/2:f[e];if(n-Math.abs(o)>=h.area[3]-1&&n-Math.abs(o)<=h.width-h.area[1]+1){c.beginPath();c.setFontSize(g);c.setFillStyle(h.xAxis.fontColor||h.fontColor);c.fillText(String(i),f[e]+a,u+h.xAxis.marginTop*h.pix+(h.xAxis.lineHeight-h.xAxis.fontSize)*h.pix/2+h.xAxis.fontSize*h.pix);c.closePath();c.stroke()}})}else{i.forEach(function(t,e){var i=h.xAxis.formatter?h.xAxis.formatter(t):t;var a=h._scrollDistance_||0;var r=p=="center"?f[e]+d/2:f[e];if(r-Math.abs(a)>=h.area[3]-1&&r-Math.abs(a)<=h.width-h.area[1]+1){c.save();c.beginPath();c.setFontSize(g);c.setFillStyle(h.xAxis.fontColor||h.fontColor);var o=measureText(String(i),g,c);var n=f[e];if(p=="center"){n=f[e]+d/2}var l=0;if(h.xAxis.scrollShow){l=6*h.pix}var s=u+h.xAxis.marginTop*h.pix+g-g*Math.abs(Math.sin(x._xAxisTextAngle_));if(h.xAxis.rotateAngle<0){n-=g/2;o=0}else{n+=g/2;o=-o}c.translate(n,s);c.rotate(-1*x._xAxisTextAngle_);c.fillText(String(i),o,0);c.closePath();c.stroke();c.restore()}})}}c.restore();if(h.xAxis.title){c.beginPath();c.setFontSize(h.xAxis.titleFontSize*h.pix);c.setFillStyle(h.xAxis.titleFontColor);c.fillText(String(h.xAxis.title),h.width-h.area[1]+h.xAxis.titleOffsetX*h.pix,h.height-h.area[2]+h.xAxis.marginTop*h.pix+(h.xAxis.lineHeight-h.xAxis.titleFontSize)*h.pix/2+(h.xAxis.titleFontSize+h.xAxis.titleOffsetY)*h.pix);c.closePath();c.stroke()}if(h.xAxis.axisLine){c.beginPath();c.setStrokeStyle(h.xAxis.axisLineColor);c.setLineWidth(1*h.pix);c.moveTo(t,h.height-h.area[2]);c.lineTo(i,h.height-h.area[2]);c.stroke()}}function drawYAxisGrid(x,e,c,i){if(e.yAxis.disableGrid===true){return}let t=e.height-e.area[0]-e.area[2];let a=t/e.yAxis.splitNumber;let r=e.area[3];let o=e.chartData.xAxisData.xAxisPoints,n=e.chartData.xAxisData.eachSpacing;let l=n*(o.length-1);if(e.type=="mount"&&e.extra&&e.extra.mount&&e.extra.mount.widthRatio&&e.extra.mount.widthRatio>1){if(e.extra.mount.widthRatio>2)e.extra.mount.widthRatio=2;l+=(e.extra.mount.widthRatio-1)*n}let f=r+l;let s=[];let h=1;if(e.xAxis.axisLine===false){h=0}for(let t=h;t<e.yAxis.splitNumber+1;t++){s.push(e.height-e.area[2]-a*t)}i.save();if(e._scrollDistance_&&e._scrollDistance_!==0){i.translate(e._scrollDistance_,0)}if(e.yAxis.gridType=="dash"){i.setLineDash([e.yAxis.dashLength*e.pix,e.yAxis.dashLength*e.pix])}i.setStrokeStyle(e.yAxis.gridColor);i.setLineWidth(1*e.pix);s.forEach(function(t,e){i.beginPath();i.moveTo(r,t);i.lineTo(f,t);i.stroke()});i.setLineDash([]);i.restore()}function drawYAxis(e,h,i,x){if(h.yAxis.disabled===true){return}var a=h.height-h.area[0]-h.area[2];var r=a/h.yAxis.splitNumber;var o=h.area[3];var n=h.width-h.area[1];var t=h.height-h.area[2];x.beginPath();x.setFillStyle(h.background);if(h.enableScroll==true&&h.xAxis.scrollPosition&&h.xAxis.scrollPosition!=="left"){x.fillRect(0,0,o,t+2*h.pix)}if(h.enableScroll==true&&h.xAxis.scrollPosition&&h.xAxis.scrollPosition!=="right"){x.fillRect(n,0,h.width,t+2*h.pix)}x.closePath();x.stroke();let c=h.area[3];let f=h.width-h.area[1];let d=h.area[3]+(h.width-h.area[1]-h.area[3])/2;if(h.yAxis.data){for(let e=0;e<h.yAxis.data.length;e++){let s=h.yAxis.data[e];var p=[];if(s.type==="categories"){for(let t=0;t<=s.categories.length;t++){p.push(h.area[0]+a/s.categories.length/2+a/s.categories.length*t)}}else{for(let t=0;t<=h.yAxis.splitNumber;t++){p.push(h.area[0]+r*t)}}if(s.disabled!==true){let t=h.chartData.yAxisData.rangesFormat[e];let o=s.fontSize?s.fontSize*h.pix:i.fontSize;let n=h.chartData.yAxisData.yAxisWidth[e];let l=s.textAlign||"right";t.forEach(function(t,e){var i=p[e];x.beginPath();x.setFontSize(o);x.setLineWidth(1*h.pix);x.setStrokeStyle(s.axisLineColor||"#cccccc");x.setFillStyle(s.fontColor||h.fontColor);let a=0;let r=4*h.pix;if(n.position=="left"){if(s.calibration==true){x.moveTo(c,i);x.lineTo(c-3*h.pix,i);r+=3*h.pix}switch(l){case"left":x.setTextAlign("left");a=c-n.width;break;case"right":x.setTextAlign("right");a=c-r;break;default:x.setTextAlign("center");a=c-n.width/2}x.fillText(String(t),a,i+o/2-3*h.pix)}else if(n.position=="right"){if(s.calibration==true){x.moveTo(f,i);x.lineTo(f+3*h.pix,i);r+=3*h.pix}switch(l){case"left":x.setTextAlign("left");a=f+r;break;case"right":x.setTextAlign("right");a=f+n.width;break;default:x.setTextAlign("center");a=f+n.width/2}x.fillText(String(t),a,i+o/2-3*h.pix)}else if(n.position=="center"){if(s.calibration==true){x.moveTo(d,i);x.lineTo(d-3*h.pix,i);r+=3*h.pix}switch(l){case"left":x.setTextAlign("left");a=d-n.width;break;case"right":x.setTextAlign("right");a=d-r;break;default:x.setTextAlign("center");a=d-n.width/2}x.fillText(String(t),a,i+o/2-3*h.pix)}x.closePath();x.stroke();x.setTextAlign("left")});if(s.axisLine!==false){x.beginPath();x.setStrokeStyle(s.axisLineColor||"#cccccc");x.setLineWidth(1*h.pix);if(n.position=="left"){x.moveTo(c,h.height-h.area[2]);x.lineTo(c,h.area[0])}else if(n.position=="right"){x.moveTo(f,h.height-h.area[2]);x.lineTo(f,h.area[0])}else if(n.position=="center"){x.moveTo(d,h.height-h.area[2]);x.lineTo(d,h.area[0])}x.stroke()}if(h.yAxis.showTitle){let t=s.titleFontSize*h.pix||i.fontSize;let e=s.title;x.beginPath();x.setFontSize(t);x.setFillStyle(s.titleFontColor||h.fontColor);if(n.position=="left"){x.fillText(e,c-measureText(e,t,x)/2+(s.titleOffsetX||0),h.area[0]-(10-(s.titleOffsetY||0))*h.pix)}else if(n.position=="right"){x.fillText(e,f-measureText(e,t,x)/2+(s.titleOffsetX||0),h.area[0]-(10-(s.titleOffsetY||0))*h.pix)}else if(n.position=="center"){x.fillText(e,d-measureText(e,t,x)/2+(s.titleOffsetX||0),h.area[0]-(10-(s.titleOffsetY||0))*h.pix)}x.closePath();x.stroke()}if(n.position=="left"){c-=n.width+h.yAxis.padding*h.pix}else{f+=n.width+h.yAxis.padding*h.pix}}}}}function drawLegend(t,l,y,s,e){if(l.legend.show===false){return}let h=e.legendData;let i=h.points;let x=h.area;let c=l.legend.padding*l.pix;let f=l.legend.fontSize*l.pix;let d=15*l.pix;let p=5*l.pix;let u=l.legend.itemGap*l.pix;let g=Math.max(l.legend.lineHeight*l.pix,f);s.beginPath();s.setLineWidth(l.legend.borderWidth*l.pix);s.setStrokeStyle(l.legend.borderColor);s.setFillStyle(l.legend.backgroundColor);s.moveTo(x.start.x,x.start.y);s.rect(x.start.x,x.start.y,x.width,x.height);s.closePath();s.fill();s.stroke();i.forEach(function(a,t){let e=0;let i=0;e=h.widthArr[t];i=h.heightArr[t];let r=0;let o=0;if(l.legend.position=="top"||l.legend.position=="bottom"){switch(l.legend.float){case"left":r=x.start.x+c;break;case"right":r=x.start.x+x.width-e;break;default:r=x.start.x+(x.width-e)/2}o=x.start.y+c+t*g}else{if(t==0){e=0}else{e=h.widthArr[t-1]}r=x.start.x+c+e;o=x.start.y+c+(x.height-i)/2}s.setFontSize(y.fontSize);for(let i=0;i<a.length;i++){let t=a[i];t.area=[0,0,0,0];t.area[0]=r;t.area[1]=o;t.area[3]=o+g;s.beginPath();s.setLineWidth(1*l.pix);s.setStrokeStyle(t.show?t.color:l.legend.hiddenColor);s.setFillStyle(t.show?t.color:l.legend.hiddenColor);switch(t.legendShape){case"line":s.moveTo(r,o+.5*g-2*l.pix);s.fillRect(r,o+.5*g-2*l.pix,15*l.pix,4*l.pix);break;case"triangle":s.moveTo(r+7.5*l.pix,o+.5*g-5*l.pix);s.lineTo(r+2.5*l.pix,o+.5*g+5*l.pix);s.lineTo(r+12.5*l.pix,o+.5*g+5*l.pix);s.lineTo(r+7.5*l.pix,o+.5*g-5*l.pix);break;case"diamond":s.moveTo(r+7.5*l.pix,o+.5*g-5*l.pix);s.lineTo(r+2.5*l.pix,o+.5*g);s.lineTo(r+7.5*l.pix,o+.5*g+5*l.pix);s.lineTo(r+12.5*l.pix,o+.5*g);s.lineTo(r+7.5*l.pix,o+.5*g-5*l.pix);break;case"circle":s.moveTo(r+7.5*l.pix,o+.5*g);s.arc(r+7.5*l.pix,o+.5*g,5*l.pix,0,2*Math.PI);break;case"rect":s.moveTo(r,o+.5*g-5*l.pix);s.fillRect(r,o+.5*g-5*l.pix,15*l.pix,10*l.pix);break;case"square":s.moveTo(r+5*l.pix,o+.5*g-5*l.pix);s.fillRect(r+5*l.pix,o+.5*g-5*l.pix,10*l.pix,10*l.pix);break;case"none":break;default:s.moveTo(r,o+.5*g-5*l.pix);s.fillRect(r,o+.5*g-5*l.pix,15*l.pix,10*l.pix)}s.closePath();s.fill();s.stroke();r+=d+p;let e=.5*g+.5*f-2;const n=t.legendText?t.legendText:t.name;s.beginPath();s.setFontSize(f);s.setFillStyle(t.show?l.legend.fontColor:l.legend.hiddenColor);s.fillText(n,r,o+e);s.closePath();s.stroke();if(l.legend.position=="top"||l.legend.position=="bottom"){r+=measureText(n,f,s)+u;t.area[2]=r}else{t.area[2]=r+measureText(n,f,s)+u;r-=d+p;o+=g}}})}function drawPieDataPoints(t,r,e,o){var i=arguments.length>4&&arguments[4]!==undefined?arguments[4]:1;var n=assign({},{activeOpacity:.5,activeRadius:10,offsetAngle:0,labelWidth:15,ringWidth:30,customRadius:0,border:false,borderWidth:2,borderColor:"#FFFFFF",centerColor:"#FFFFFF",linearType:"none",customColor:[]},r.type=="pie"?r.extra.pie:r.extra.ring);var l={x:r.area[3]+(r.width-r.area[1]-r.area[3])/2,y:r.area[0]+(r.height-r.area[0]-r.area[2])/2};if(e.pieChartLinePadding==0){e.pieChartLinePadding=n.activeRadius*r.pix}var a=Math.min((r.width-r.area[1]-r.area[3])/2-e.pieChartLinePadding-e.pieChartTextPadding-e._pieTextMaxLength_,(r.height-r.area[0]-r.area[2])/2-e.pieChartLinePadding-e.pieChartTextPadding);a=a<10?10:a;if(n.customRadius>0){a=n.customRadius*r.pix}t=getPieDataPoints(t,a,i);var h=n.activeRadius*r.pix;n.customColor=fillCustomColor(n.linearType,n.customColor,t,e);t=t.map(function(t){t._start_+=n.offsetAngle*Math.PI/180;return t});t.forEach(function(t,e){if(r.tooltip){if(r.tooltip.index==e){o.beginPath();o.setFillStyle(hexToRgb(t.color,n.activeOpacity||.5));o.moveTo(l.x,l.y);o.arc(l.x,l.y,t._radius_+h,t._start_,t._start_+2*t._proportion_*Math.PI);o.closePath();o.fill()}}o.beginPath();o.setLineWidth(n.borderWidth*r.pix);o.lineJoin="round";o.setStrokeStyle(n.borderColor);var i=t.color;if(n.linearType=="custom"){var a;if(o.createCircularGradient){a=o.createCircularGradient(l.x,l.y,t._radius_)}else{a=o.createRadialGradient(l.x,l.y,0,l.x,l.y,t._radius_)}a.addColorStop(0,hexToRgb(n.customColor[t.linearIndex],1));a.addColorStop(1,hexToRgb(t.color,1));i=a}o.setFillStyle(i);o.moveTo(l.x,l.y);o.arc(l.x,l.y,t._radius_,t._start_,t._start_+2*t._proportion_*Math.PI);o.closePath();o.fill();if(n.border==true){o.stroke()}});if(r.type==="ring"){var s=a*.6;if(typeof n.ringWidth==="number"&&n.ringWidth>0){s=Math.max(0,a-n.ringWidth*r.pix)}o.beginPath();o.setFillStyle(n.centerColor);o.moveTo(l.x,l.y);o.arc(l.x,l.y,s,0,2*Math.PI);o.closePath();o.fill()}if(r.dataLabel!==false&&i===1){drawPieText(t,r,e,o,a,l)}if(i===1&&r.type==="ring"){drawRingTitle(r,e,o,l)}return{center:l,radius:a,series:t}}function drawRoseDataPoints(t,r,e,o){var i=arguments.length>4&&arguments[4]!==undefined?arguments[4]:1;var n=assign({},{type:"area",activeOpacity:.5,activeRadius:10,offsetAngle:0,labelWidth:15,border:false,borderWidth:2,borderColor:"#FFFFFF",linearType:"none",customColor:[]},r.extra.rose);if(e.pieChartLinePadding==0){e.pieChartLinePadding=n.activeRadius*r.pix}var l={x:r.area[3]+(r.width-r.area[1]-r.area[3])/2,y:r.area[0]+(r.height-r.area[0]-r.area[2])/2};var a=Math.min((r.width-r.area[1]-r.area[3])/2-e.pieChartLinePadding-e.pieChartTextPadding-e._pieTextMaxLength_,(r.height-r.area[0]-r.area[2])/2-e.pieChartLinePadding-e.pieChartTextPadding);a=a<10?10:a;var s=n.minRadius||a*.5;if(a<s){a=s+10}t=getRoseDataPoints(t,n.type,s,a,i);var h=n.activeRadius*r.pix;n.customColor=fillCustomColor(n.linearType,n.customColor,t,e);t=t.map(function(t){t._start_+=(n.offsetAngle||0)*Math.PI/180;return t});t.forEach(function(t,e){if(r.tooltip){if(r.tooltip.index==e){o.beginPath();o.setFillStyle(hexToRgb(t.color,n.activeOpacity||.5));o.moveTo(l.x,l.y);o.arc(l.x,l.y,h+t._radius_,t._start_,t._start_+2*t._rose_proportion_*Math.PI);o.closePath();o.fill()}}o.beginPath();o.setLineWidth(n.borderWidth*r.pix);o.lineJoin="round";o.setStrokeStyle(n.borderColor);var i=t.color;if(n.linearType=="custom"){var a;if(o.createCircularGradient){a=o.createCircularGradient(l.x,l.y,t._radius_)}else{a=o.createRadialGradient(l.x,l.y,0,l.x,l.y,t._radius_)}a.addColorStop(0,hexToRgb(n.customColor[t.linearIndex],1));a.addColorStop(1,hexToRgb(t.color,1));i=a}o.setFillStyle(i);o.moveTo(l.x,l.y);o.arc(l.x,l.y,t._radius_,t._start_,t._start_+2*t._rose_proportion_*Math.PI);o.closePath();o.fill();if(n.border==true){o.stroke()}});if(r.dataLabel!==false&&i===1){drawPieText(t,r,e,o,a,l)}return{center:l,radius:a,series:t}}function drawCanvas(t,e){e.save();e.translate(0,.5);e.restore();e.draw()}var Timing={easeIn:function t(e){return Math.pow(e,3)},easeOut:function t(e){return Math.pow(e-1,3)+1},easeInOut:function t(e){if((e/=.5)<1){return.5*Math.pow(e,3)}else{return.5*(Math.pow(e-2,3)+2)}},linear:function t(e){return e}};function Animation(r){this.isStop=false;r.duration=typeof r.duration==="undefined"?1e3:r.duration;r.timing=r.timing||"easeInOut";var o=17;function t(){if(typeof setTimeout!=="undefined"){return function(e,t){setTimeout(function(){var t=+new Date;e(t)},t)}}else if(typeof requestAnimationFrame!=="undefined"){return requestAnimationFrame}else{return function(t){t(null)}}}var n=t();var l=null;var s=function t(e){if(e===null||this.isStop===true){r.onProcess&&r.onProcess(1);r.onAnimationFinish&&r.onAnimationFinish();return}if(l===null){l=e}if(e-l<r.duration){var i=(e-l)/r.duration;var a=Timing[r.timing];i=a(i);r.onProcess&&r.onProcess(i);n(s,o)}else{r.onProcess&&r.onProcess(1);r.onAnimationFinish&&r.onAnimationFinish()}};s=s.bind(this);n(s,o)}Animation.prototype.stop=function(){this.isStop=true};function drawCharts(t,l,n,s){var h=this;var x=l.series;if(t==="pie"||t==="ring"||t==="mount"||t==="rose"||t==="funnel"){x=fixPieSeries(x,l,n)}var c=l.categories;if(t==="mount"){c=[];for(let t=0;t<x.length;t++){if(x[t].show!==false)c.push(x[t].name)}l.categories=c}x=fillSeries(x,l,n);var e=l.animation?l.duration:0;h.animationInstance&&h.animationInstance.stop();var i=null;if(t=="candle"){let t=assign({},l.extra.candle.average);if(t.show){i=calCandleMA(t.day,t.name,t.color,x[0].data);i=fillSeries(i,l,n);l.seriesMA=i}else if(l.seriesMA){i=l.seriesMA=fillSeries(l.seriesMA,l,n)}else{i=x}}else{i=x}l._series_=x=filterSeries(x);l.area=new Array(4);for(let t=0;t<4;t++){l.area[t]=l.padding[t]*l.pix}var r=calLegendData(i,l,n,l.chartData,s),o=r.area.wholeHeight,f=r.area.wholeWidth;switch(l.legend.position){case"top":l.area[0]+=o;break;case"bottom":l.area[2]+=o;break;case"left":l.area[3]+=f;break;case"right":l.area[1]+=f;break}let d={},a=0;if(l.type==="line"||l.type==="column"||l.type==="mount"||l.type==="area"||l.type==="mix"||l.type==="candle"||l.type==="scatter"||l.type==="bubble"||l.type==="bar"){d=calYAxisData(x,l,n,s);a=d.yAxisWidth;if(l.yAxis.showTitle){let e=0;for(let t=0;t<l.yAxis.data.length;t++){e=Math.max(e,l.yAxis.data[t].titleFontSize?l.yAxis.data[t].titleFontSize*l.pix:n.fontSize)}l.area[0]+=e}let e=0,i=0;for(let t=0;t<a.length;t++){if(a[t].position=="left"){if(i>0){l.area[3]+=a[t].width+l.yAxis.padding*l.pix}else{l.area[3]+=a[t].width}i+=1}else if(a[t].position=="right"){if(e>0){l.area[1]+=a[t].width+l.yAxis.padding*l.pix}else{l.area[1]+=a[t].width}e+=1}}}else{n.yAxisWidth=a}l.chartData.yAxisData=d;if(l.categories&&l.categories.length&&l.type!=="radar"&&l.type!=="gauge"&&l.type!=="bar"){l.chartData.xAxisData=getXAxisPoints(l.categories,l,n);let t=calCategoriesData(l.categories,l,n,l.chartData.xAxisData.eachSpacing,s),e=t.xAxisHeight,i=t.angle;n.xAxisHeight=e;n._xAxisTextAngle_=i;l.area[2]+=e;l.chartData.categoriesData=t}else{if(l.type==="line"||l.type==="area"||l.type==="scatter"||l.type==="bubble"||l.type==="bar"){l.chartData.xAxisData=calXAxisData(x,l,n,s);c=l.chartData.xAxisData.rangesFormat;let t=calCategoriesData(c,l,n,l.chartData.xAxisData.eachSpacing,s),e=t.xAxisHeight,i=t.angle;n.xAxisHeight=e;n._xAxisTextAngle_=i;l.area[2]+=e;l.chartData.categoriesData=t}else{l.chartData.xAxisData={xAxisPoints:[]}}}if(l.enableScroll&&l.xAxis.scrollAlign=="right"&&l._scrollDistance_===undefined){let t=0,e=l.chartData.xAxisData.xAxisPoints,i=l.chartData.xAxisData.startX,a=l.chartData.xAxisData.endX,r=l.chartData.xAxisData.eachSpacing;let o=r*(e.length-1);let n=a-i;t=n-o;h.scrollOption.currentOffset=t;h.scrollOption.startTouchX=t;h.scrollOption.distance=0;h.scrollOption.lastMoveTime=0;l._scrollDistance_=t}if(t==="pie"||t==="ring"||t==="rose"){n._pieTextMaxLength_=l.dataLabel===false?0:getPieTextMaxLength(i,n,s,l)}switch(t){case"line":this.animationInstance=new Animation({timing:l.timing,duration:e,onProcess:function t(e){s.clearRect(0,0,l.width,l.height);if(l.rotate){contextRotate(s,l)}drawYAxisGrid(c,l,n,s);drawXAxis(c,l,n,s);var i=drawLineDataPoints(x,l,n,s,e),a=i.xAxisPoints,r=i.calPoints,o=i.eachSpacing;l.chartData.xAxisPoints=a;l.chartData.calPoints=r;l.chartData.eachSpacing=o;drawYAxis(x,l,n,s);if(l.enableMarkLine!==false&&e===1){drawMarkLine(l,n,s)}drawLegend(l.series,l,n,s,l.chartData);drawToolTipBridge(l,n,s,e,o,a);drawCanvas(l,s)},onAnimationFinish:function t(){h.uevent.trigger("renderComplete")}});break;case"mix":this.animationInstance=new Animation({timing:l.timing,duration:e,onProcess:function t(e){s.clearRect(0,0,l.width,l.height);if(l.rotate){contextRotate(s,l)}drawYAxisGrid(c,l,n,s);drawXAxis(c,l,n,s);var i=drawMixDataPoints(x,l,n,s,e),a=i.xAxisPoints,r=i.calPoints,o=i.eachSpacing;l.chartData.xAxisPoints=a;l.chartData.calPoints=r;l.chartData.eachSpacing=o;drawYAxis(x,l,n,s);if(l.enableMarkLine!==false&&e===1){drawMarkLine(l,n,s)}drawLegend(l.series,l,n,s,l.chartData);drawToolTipBridge(l,n,s,e,o,a);drawCanvas(l,s)},onAnimationFinish:function t(){h.uevent.trigger("renderComplete")}});break;case"column":this.animationInstance=new Animation({timing:l.timing,duration:e,onProcess:function t(e){s.clearRect(0,0,l.width,l.height);if(l.rotate){contextRotate(s,l)}drawYAxisGrid(c,l,n,s);drawXAxis(c,l,n,s);var i=drawColumnDataPoints(x,l,n,s,e),a=i.xAxisPoints,r=i.calPoints,o=i.eachSpacing;l.chartData.xAxisPoints=a;l.chartData.calPoints=r;l.chartData.eachSpacing=o;drawYAxis(x,l,n,s);if(l.enableMarkLine!==false&&e===1){drawMarkLine(l,n,s)}drawLegend(l.series,l,n,s,l.chartData);drawToolTipBridge(l,n,s,e,o,a);drawCanvas(l,s)},onAnimationFinish:function t(){h.uevent.trigger("renderComplete")}});break;case"bar":this.animationInstance=new Animation({timing:l.timing,duration:e,onProcess:function t(e){s.clearRect(0,0,l.width,l.height);if(l.rotate){contextRotate(s,l)}drawXAxis(c,l,n,s);var i=drawBarDataPoints(x,l,n,s,e),a=i.yAxisPoints,r=i.calPoints,o=i.eachSpacing;l.chartData.yAxisPoints=a;l.chartData.xAxisPoints=l.chartData.xAxisData.xAxisPoints;l.chartData.calPoints=r;l.chartData.eachSpacing=o;drawYAxis(x,l,n,s);if(l.enableMarkLine!==false&&e===1){drawMarkLine(l,n,s)}drawLegend(l.series,l,n,s,l.chartData);drawToolTipBridge(l,n,s,e,o,a);drawCanvas(l,s)},onAnimationFinish:function t(){h.uevent.trigger("renderComplete")}});break;case"ring":this.animationInstance=new Animation({timing:l.timing,duration:e,onProcess:function t(e){s.clearRect(0,0,l.width,l.height);if(l.rotate){contextRotate(s,l)}l.chartData.pieData=drawPieDataPoints(x,l,n,s,e);drawLegend(l.series,l,n,s,l.chartData);drawToolTipBridge(l,n,s,e);drawCanvas(l,s)},onAnimationFinish:function t(){h.uevent.trigger("renderComplete")}});break;case"pie":this.animationInstance=new Animation({timing:l.timing,duration:e,onProcess:function t(e){s.clearRect(0,0,l.width,l.height);if(l.rotate){contextRotate(s,l)}l.chartData.pieData=drawPieDataPoints(x,l,n,s,e);drawLegend(l.series,l,n,s,l.chartData);drawToolTipBridge(l,n,s,e);drawCanvas(l,s)},onAnimationFinish:function t(){h.uevent.trigger("renderComplete")}});break;case"rose":this.animationInstance=new Animation({timing:l.timing,duration:e,onProcess:function t(e){s.clearRect(0,0,l.width,l.height);if(l.rotate){contextRotate(s,l)}l.chartData.pieData=drawRoseDataPoints(x,l,n,s,e);drawLegend(l.series,l,n,s,l.chartData);drawToolTipBridge(l,n,s,e);drawCanvas(l,s)},onAnimationFinish:function t(){h.uevent.trigger("renderComplete")}});break}}function uChartsEvent(){this.events={}}uChartsEvent.prototype.addEventListener=function(t,e){this.events[t]=this.events[t]||[];this.events[t].push(e)};uChartsEvent.prototype.delEventListener=function(t){this.events[t]=[]};uChartsEvent.prototype.trigger=function(){for(var t=arguments.length,e=Array(t),i=0;i<t;i++){e[i]=arguments[i]}var a=e[0];var r=e.slice(1);if(!!this.events[a]){this.events[a].forEach(function(t){try{t.apply(null,r)}catch(t){}})}};var uCharts=function t(i){i.pix=i.pixelRatio?i.pixelRatio:1;i.fontSize=i.fontSize?i.fontSize:13;i.fontColor=i.fontColor?i.fontColor:config.fontColor;if(i.background==""||i.background=="none"){i.background="#FFFFFF"}i.title=assign({},i.title);i.subtitle=assign({},i.subtitle);i.duration=i.duration?i.duration:1e3;i.yAxis=assign({},{data:[],showTitle:false,disabled:false,disableGrid:false,gridSet:"number",splitNumber:5,gridType:"solid",dashLength:4*i.pix,gridColor:"#cccccc",padding:10,fontColor:"#666666"},i.yAxis);i.xAxis=assign({},{rotateLabel:false,rotateAngle:45,disabled:false,disableGrid:false,splitNumber:5,calibration:false,fontColor:"#666666",fontSize:13,lineHeight:20,marginTop:0,gridType:"solid",dashLength:4,scrollAlign:"left",boundaryGap:"center",axisLine:true,axisLineColor:"#cccccc",titleFontSize:13,titleOffsetY:0,titleOffsetX:0,titleFontColor:"#666666"},i.xAxis);i.xAxis.scrollPosition=i.xAxis.scrollAlign;i.legend=assign({},{show:true,position:"bottom",float:"center",backgroundColor:"rgba(0,0,0,0)",borderColor:"rgba(0,0,0,0)",borderWidth:0,padding:5,margin:5,itemGap:10,fontSize:i.fontSize,lineHeight:i.fontSize,fontColor:i.fontColor,formatter:{},hiddenColor:"#CECECE"},i.legend);i.extra=assign({tooltip:{legendShape:"auto"}},i.extra);i.rotate=i.rotate?true:false;i.animation=i.animation?true:false;i.rotate=i.rotate?true:false;i.canvas2d=i.canvas2d?true:false;let e=assign({},config);e.color=i.color?i.color:e.color;if(i.type=="pie"){e.pieChartLinePadding=i.dataLabel===false?0:i.extra.pie.labelWidth*i.pix||e.pieChartLinePadding*i.pix}if(i.type=="ring"){e.pieChartLinePadding=i.dataLabel===false?0:i.extra.ring.labelWidth*i.pix||e.pieChartLinePadding*i.pix}if(i.type=="rose"){e.pieChartLinePadding=i.dataLabel===false?0:i.extra.rose.labelWidth*i.pix||e.pieChartLinePadding*i.pix}e.pieChartTextPadding=i.dataLabel===false?0:e.pieChartTextPadding*i.pix;e.rotate=i.rotate;if(i.rotate){let t=i.width;let e=i.height;i.width=e;i.height=t}i.padding=i.padding?i.padding:e.padding;e.yAxisWidth=config.yAxisWidth*i.pix;e.fontSize=i.fontSize*i.pix;e.titleFontSize=config.titleFontSize*i.pix;e.subtitleFontSize=config.subtitleFontSize*i.pix;if(!i.context){throw new Error("[uCharts] 未获取到context！注意：v2.0版本后，需要自行获取canvas的绘图上下文并传入opts.context！")}this.context=i.context;if(!this.context.setTextAlign){this.context.setStrokeStyle=function(t){return this.strokeStyle=t};this.context.setLineWidth=function(t){return this.lineWidth=t};this.context.setLineCap=function(t){return this.lineCap=t};this.context.setFontSize=function(t){return this.font=t+"px sans-serif"};this.context.setFillStyle=function(t){return this.fillStyle=t};this.context.setTextAlign=function(t){return this.textAlign=t};this.context.setTextBaseline=function(t){return this.textBaseline=t};this.context.setShadow=function(t,e,i,a){this.shadowColor=a;this.shadowOffsetX=t;this.shadowOffsetY=e;this.shadowBlur=i};this.context.draw=function(){}}if(!this.context.setLineDash){this.context.setLineDash=function(t){}}i.chartData={};this.uevent=new uChartsEvent;this.scrollOption={currentOffset:0,startTouchX:0,distance:0,lastMoveTime:0};this.opts=i;this.config=e;drawCharts.call(this,i.type,i,e,this.context)};uCharts.prototype.updateData=function(){let t=arguments.length>0&&arguments[0]!==undefined?arguments[0]:{};this.opts=assign({},this.opts,t);this.opts.updateData=true;let x=t.scrollPosition||"current";switch(x){case"current":this.opts._scrollDistance_=this.scrollOption.currentOffset;break;case"left":this.opts._scrollDistance_=0;this.scrollOption={currentOffset:0,startTouchX:0,distance:0,lastMoveTime:0};break;case"right":let t=calYAxisData(this.opts.series,this.opts,this.config,this.context),e=t.yAxisWidth;this.config.yAxisWidth=e;let i=0;let a=getXAxisPoints(this.opts.categories,this.opts,this.config),r=a.xAxisPoints,o=a.startX,n=a.endX,l=a.eachSpacing;let s=l*(r.length-1);let h=n-o;i=h-s;this.scrollOption={currentOffset:i,startTouchX:i,distance:0,lastMoveTime:0};this.opts._scrollDistance_=i;break}drawCharts.call(this,this.opts.type,this.opts,this.config,this.context)};uCharts.prototype.zoom=function(){var t=arguments.length>0&&arguments[0]!==undefined?arguments[0]:this.opts.xAxis.itemCount;if(this.opts.enableScroll!==true){console.log("[uCharts] 请启用滚动条后使用");return}let e=Math.round(Math.abs(this.scrollOption.currentOffset)/this.opts.chartData.eachSpacing)+Math.round(this.opts.xAxis.itemCount/2);this.opts.animation=false;this.opts.xAxis.itemCount=t.itemCount;let i=calYAxisData(this.opts.series,this.opts,this.config,this.context),a=i.yAxisWidth;this.config.yAxisWidth=a;let r=0;let o=getXAxisPoints(this.opts.categories,this.opts,this.config),h=o.xAxisPoints,x=o.startX,c=o.endX,n=o.eachSpacing;let f=n*e;let l=c-x;let s=l-n*(h.length-1);r=l/2-f;if(r>0){r=0}if(r<s){r=s}this.scrollOption={currentOffset:r,startTouchX:0,distance:0,lastMoveTime:0};calValidDistance(this,r,this.opts.chartData,this.config,this.opts);this.opts._scrollDistance_=r;drawCharts.call(this,this.opts.type,this.opts,this.config,this.context)};uCharts.prototype.dobuleZoom=function(t){if(this.opts.enableScroll!==true){console.log("[uCharts] 请启用滚动条后使用");return}const i=t.changedTouches;if(i.length<2){return}for(var e=0;e<i.length;e++){i[e].x=i[e].x?i[e].x:i[e].clientX;i[e].y=i[e].y?i[e].y:i[e].clientY}const a=[getTouches(i[0],this.opts,t),getTouches(i[1],this.opts,t)];const x=Math.abs(a[0].x-a[1].x);if(!this.scrollOption.moveCount){let t={changedTouches:[{x:i[0].x,y:this.opts.area[0]/this.opts.pix+2}]};let e={changedTouches:[{x:i[1].x,y:this.opts.area[0]/this.opts.pix+2}]};if(this.opts.rotate){t={changedTouches:[{x:this.opts.height/this.opts.pix-this.opts.area[0]/this.opts.pix-2,y:i[0].y}]};e={changedTouches:[{x:this.opts.height/this.opts.pix-this.opts.area[0]/this.opts.pix-2,y:i[1].y}]}}const s=this.getCurrentDataIndex(t).index;const h=this.getCurrentDataIndex(e).index;const v=Math.abs(s-h);this.scrollOption.moveCount=v;this.scrollOption.moveCurrent1=Math.min(s,h);this.scrollOption.moveCurrent2=Math.max(s,h);return}let c=x/this.scrollOption.moveCount;let r=(this.opts.width-this.opts.area[1]-this.opts.area[3])/c;r=r<=2?2:r;r=r>=this.opts.categories.length?this.opts.categories.length:r;this.opts.animation=false;this.opts.xAxis.itemCount=r;let o=0;let n=getXAxisPoints(this.opts.categories,this.opts,this.config),f=n.xAxisPoints,d=n.startX,p=n.endX,l=n.eachSpacing;let u=l*this.scrollOption.moveCurrent1;let g=p-d;let y=g-l*(f.length-1);o=-u+Math.min(a[0].x,a[1].x)-this.opts.area[3]-l;if(o>0){o=0}if(o<y){o=y}this.scrollOption.currentOffset=o;this.scrollOption.startTouchX=0;this.scrollOption.distance=0;calValidDistance(this,o,this.opts.chartData,this.config,this.opts);this.opts._scrollDistance_=o;drawCharts.call(this,this.opts.type,this.opts,this.config,this.context)};uCharts.prototype.stopAnimation=function(){this.animationInstance&&this.animationInstance.stop()};uCharts.prototype.addEventListener=function(t,e){this.uevent.addEventListener(t,e)};uCharts.prototype.delEventListener=function(t){this.uevent.delEventListener(t)};uCharts.prototype.getCurrentDataIndex=function(e){var i=null;if(e.changedTouches){i=e.changedTouches[0]}else{i=e.mp.changedTouches[0]}if(i){let t=getTouches(i,this.opts,e);if(this.opts.type==="pie"||this.opts.type==="ring"){return findPieChartCurrentIndex({x:t.x,y:t.y},this.opts.chartData.pieData,this.opts)}else if(this.opts.type==="rose"){return findRoseChartCurrentIndex({x:t.x,y:t.y},this.opts.chartData.pieData,this.opts)}else if(this.opts.type==="radar"){return findRadarChartCurrentIndex({x:t.x,y:t.y},this.opts.chartData.radarData,this.opts.categories.length)}else if(this.opts.type==="funnel"){return findFunnelChartCurrentIndex({x:t.x,y:t.y},this.opts.chartData.funnelData)}else if(this.opts.type==="map"){return findMapChartCurrentIndex({x:t.x,y:t.y},this.opts)}else if(this.opts.type==="word"){return findWordChartCurrentIndex({x:t.x,y:t.y},this.opts.chartData.wordCloudData)}else if(this.opts.type==="bar"){return findBarChartCurrentIndex({x:t.x,y:t.y},this.opts.chartData.calPoints,this.opts,this.config,Math.abs(this.scrollOption.currentOffset))}else{return findCurrentIndex({x:t.x,y:t.y},this.opts.chartData.calPoints,this.opts,this.config,Math.abs(this.scrollOption.currentOffset))}}return-1};uCharts.prototype.getLegendDataIndex=function(e){var i=null;if(e.changedTouches){i=e.changedTouches[0]}else{i=e.mp.changedTouches[0]}if(i){let t=getTouches(i,this.opts,e);return findLegendIndex({x:t.x,y:t.y},this.opts.chartData.legendData)}return-1};uCharts.prototype.touchLegend=function(t){var e=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};var i=null;if(t.changedTouches){i=t.changedTouches[0]}else{i=t.mp.changedTouches[0]}if(i){var a=getTouches(i,this.opts,t);var r=this.getLegendDataIndex(t);if(r>=0){if(this.opts.type=="candle"){this.opts.seriesMA[r].show=!this.opts.seriesMA[r].show}else{this.opts.series[r].show=!this.opts.series[r].show}this.opts.animation=e.animation?true:false;this.opts._scrollDistance_=this.scrollOption.currentOffset;drawCharts.call(this,this.opts.type,this.opts,this.config,this.context)}}};uCharts.prototype.showToolTip=function(t){var e=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};var i=null;if(t.changedTouches){i=t.changedTouches[0]}else{i=t.mp.changedTouches[0]}if(!i){console.log("[uCharts] 未获取到event坐标信息")}var a=getTouches(i,this.opts,t);var x=this.scrollOption.currentOffset;var r=assign({},this.opts,{_scrollDistance_:x,animation:false});if(this.opts.type==="line"||this.opts.type==="area"||this.opts.type==="column"||this.opts.type==="scatter"||this.opts.type==="bubble"){var o=this.getCurrentDataIndex(t);var n=e.index==undefined?o.index:e.index;if(n>-1||n.length>0){var l=getSeriesDataItem(this.opts.series,n,o.group);if(l.length!==0){var s=getToolTipData(l,this.opts,n,o.group,this.opts.categories,e),c=s.textList,h=s.offset;h.y=a.y;r.tooltip={textList:e.textList!==undefined?e.textList:c,offset:e.offset!==undefined?e.offset:h,option:e,index:n,group:o.group}}}drawCharts.call(this,r.type,r,this.config,this.context)}if(this.opts.type==="bar"){var o=this.getCurrentDataIndex(t);var n=e.index==undefined?o.index:e.index;if(n>-1||n.length>0){var l=getSeriesDataItem(this.opts.series,n,o.group);if(l.length!==0){var s=getToolTipData(l,this.opts,n,o.group,this.opts.categories,e),c=s.textList,h=s.offset;h.x=a.x;r.tooltip={textList:e.textList!==undefined?e.textList:c,offset:e.offset!==undefined?e.offset:h,option:e,index:n}}}drawCharts.call(this,r.type,r,this.config,this.context)}if(this.opts.type==="mix"){var o=this.getCurrentDataIndex(t);var n=e.index==undefined?o.index:e.index;if(n>-1){var x=this.scrollOption.currentOffset;var r=assign({},this.opts,{_scrollDistance_:x,animation:false});var l=getSeriesDataItem(this.opts.series,n);if(l.length!==0){var f=getMixToolTipData(l,this.opts,n,this.opts.categories,e),c=f.textList,h=f.offset;h.y=a.y;r.tooltip={textList:e.textList?e.textList:c,offset:e.offset!==undefined?e.offset:h,option:e,index:n}}}drawCharts.call(this,r.type,r,this.config,this.context)}if(this.opts.type==="pie"||this.opts.type==="ring"||this.opts.type==="rose"||this.opts.type==="funnel"){var n=e.index==undefined?this.getCurrentDataIndex(t):e.index;if(n>-1){var r=assign({},this.opts,{animation:false});var l=assign({},r._series_[n]);var c=[{text:e.formatter?e.formatter(l,undefined,n,r):l.name+": "+l.data,color:l.color,legendShape:this.opts.extra.tooltip.legendShape=="auto"?l.legendShape:this.opts.extra.tooltip.legendShape}];var h={x:a.x,y:a.y};r.tooltip={textList:e.textList?e.textList:c,offset:e.offset!==undefined?e.offset:h,option:e,index:n}}drawCharts.call(this,r.type,r,this.config,this.context)}};uCharts.prototype.translate=function(t){this.scrollOption={currentOffset:t,startTouchX:t,distance:0,lastMoveTime:0};let e=assign({},this.opts,{_scrollDistance_:t,animation:false});drawCharts.call(this,this.opts.type,e,this.config,this.context)};uCharts.prototype.scrollStart=function(t){var e=null;if(t.changedTouches){e=t.changedTouches[0]}else{e=t.mp.changedTouches[0]}var i=getTouches(e,this.opts,t);if(e&&this.opts.enableScroll===true){this.scrollOption.startTouchX=i.x}};uCharts.prototype.scroll=function(t){if(this.scrollOption.lastMoveTime===0){this.scrollOption.lastMoveTime=Date.now()}let e=this.opts.touchMoveLimit||60;let i=Date.now();let a=i-this.scrollOption.lastMoveTime;if(a<Math.floor(1e3/e))return;if(this.scrollOption.startTouchX==0)return;this.scrollOption.lastMoveTime=i;var r=null;if(t.changedTouches){r=t.changedTouches[0]}else{r=t.mp.changedTouches[0]}if(r&&this.opts.enableScroll===true){var o=getTouches(r,this.opts,t);var n;n=o.x-this.scrollOption.startTouchX;var l=this.scrollOption.currentOffset;var s=calValidDistance(this,l+n,this.opts.chartData,this.config,this.opts);this.scrollOption.distance=n=s-l;var h=assign({},this.opts,{_scrollDistance_:l+n,animation:false});this.opts=h;drawCharts.call(this,h.type,h,this.config,this.context);return l+n}};uCharts.prototype.scrollEnd=function(t){if(this.opts.enableScroll===true){var e=this.scrollOption,i=e.currentOffset,a=e.distance;this.scrollOption.currentOffset=i+a;this.scrollOption.distance=0;this.scrollOption.moveCount=0}};export default uCharts;